--------------------------------------------------------------------------------------------------------------------------------------------
2026-08-06版

[バグ修正]

- [フローター]: 用紙質感を適用したフローターを移動させるとアクセス違反が大量発生する

- [スポイト]: ペンによるホバー状態での右ボタンドラッグだと[ドラッグ中も色を拾う]の設定が適用されない

- [ドット絵ペン]: [スポイト方式]で[レイヤーARGB]を指定してもスポイトツールの設定が優先される


[変更]

- [スポイト]: ドラッグ中もブラシプレビューを更新するよう変更


--------------------------------------------------------------------------------------------------------------------------------------------
2026-08-05版

[バグ修正]

- [PNGファイル]: 存在しないPNGファイルを開こうとするとアクセス違反が発生して以後正常に動作しなくなる

- [文字レイヤー]: 文字レイヤーの複製のUndo/Redoを行う際にカレットの位置によっては操作が失敗する場合がある

- [手ぶれ補正]: [設定]→[キーボード操作]→[ツールの誤操作の抑制]で設定した時間内に修飾キー併用ドラッグ操作を開始すると手ぶれ補正が適用されない

- [ペンタブレット制御]: WinTab APIモードの場合にドラッグ操作の先行入力ができなくなっている
  (現在のWindowsのマウスメッセージの生成順序が以前とは異なっているように思います)

- [ブラシ系ツール]: ブラシテクスチャ名に"%"が含まれているとツール設定には"%"が除去された名前で保存される
  (次回ツールを選択した際にブラシテクスチャが正しく選択されなくなります)

- [効果ペン・散布ツール]: レイヤーマスクに正しい色で描画できない

- [散布ツール]: 形状が[通常の円形]だと描画されない
  (すみません、2026-07-29版でエンバグさせていました)

- [散布形状・散布ツール]: [角度]が-129度以下または+128度以上になると正しい角度にならない

- [自動選択ツール・バケツツール]: ループ状の領域の選択または塗り潰しを行うとフリーズする場合がある

- [画像変形]: グリッド系定規または対称定規を使用している場合に定規の無効化が反映されない

- [画像変形]: 表示倍率が50%以下だと変形開始時に変形範囲の周囲に一瞬ゴミが描画される

- [画像変形]: 特殊効果が設定されたフローターの変形を確定またはキャンセルすると効果が剥がれたりアクセス違反が発生したりする


[変更]

- [自動選択ツール・バケツツール]: ボケ足の強い線画での塗り残しを減らす対策の強化を廃止


--------------------------------------------------------------------------------------------------------------------------------------------
2026-07-30版

[バグ修正]

- [システムファイルダイアログ]: ファイル名入力欄で拡張子を削除してから保存すると常にSAI2形式になる

- [ブラシ系ツール]: にじみマップとブラシテクスチャの濃淡を反転すると正しい濃度で描画されない

- [自動選択ツール・バケツツール]: 領域検出が正常に行われない
  (すみません、2026-07-29版でエンバグさせていました)

- [設定ダイアログ]: HSV/HSLの数値表示の範囲を変更した際にHSV/HSLスライダが適切に更新されない


--------------------------------------------------------------------------------------------------------------------------------------------
2026-07-29版

[バグ修正]

- [コマンドライン引数]: プログラムが二重に起動された際に起動済みのインスタンスにコマンドライン引数を送る機能が動作していない

- [PSD/PSB保存]: レイヤーマスクが左右どちらかにズレた状態で保存される

- [ビュー]: 何かしらの理由でアクセス違反が発生することがある
  (再現できなかったので原因不明ですが、アクセス違反が発生しないよう対処しました)

- [スクラッチパッド]: ペンタブレットで描画できない

- [２値ハーフトーン]: ハーフトーンが設定されたレイヤーを複製した際にレイヤー画像が消えた状態になる

- [レイヤー移動]: 子レイヤーを持つレイヤーフォルダに設定されたレイヤーマスクの単体での移動がUndoができない

- [パース定規・パースグリッド・用紙グリッド]: Undo/Redoで消失点の有効状態およびグリッドスナップの設定が巻き戻される

- [対称定規]: １分割線対称あるいは２分割にして画像変形を行った際に軸に沿って画像が欠ける場合がある

- [自動選択ツール・バケツツール]: [膨張幅]を指定していると選択または塗り潰した箇所からやや離れた周囲に枠線状のゴミが描画される

- [自動選択ツール・バケツツール]: 領域抽出モードが[透明部分]でかつアンチエイリアスがOFFの場合に選択または塗り潰しが不透明部分に少し入り込む

- [自動選択ツール]: [操作]の指定が反映されない

- [バケツツール]: 領域検出元に別レイヤーを指定して透明色で塗り潰す場合に既存の透明部分が領域抽出に反映されない

- [効果ペン]: レイヤーマスクに正しく描画できない

- [ブラシ系ツール]: 散布の設定３に所属する画像が描画されない場合がある

- [曲線ツール・折れ線ツール]: ブラシ円が表示されない

- [色調補正系フィルタ]: またしてもレイヤーフォルダに適用できなくなっている
  (すみません、2026-07-27版の修正でエンバグさせていました)


--------------------------------------------------------------------------------------------------------------------------------------------
2026-07-27版

[バグ修正]

- [色管理]: 画像保存でICCカラープロファイルが適用された状態の画像が保存される

- [ビュー]: 選択系ツールの使用中、ビューの描画が間に合わず格子模様が表示されている部分にマウスカーソルを置くとアクセス違反が発生する

- [クリップボード]: クリップボードに図形系レイヤーが格納されているとプログラムの終了時にアクセス違反が発生する

- [水彩境界]: グレースケールモードの場合に同色で塗り潰された箇所の周囲に境界が描画されてしまう

- [２値ハーフトーン]: グレースケールモードの場合に描画部分の周囲にゴミが現れる

- [文字レイヤー]: 作成直後に文字色を変更できない、画像変形で原点がずれる、等々細かい不具合がある

- [スポイト]: 選択系ブラシの選択中はショートカットキーに割り当てた[統合画像から色を拾う]と[現在のレイヤーから色を拾う]が
  色を拾う動作ではなく選択系ブラシ用のスポイトの動作になる

- [ブラシ系ツール]: 通常レイヤー以外でCtrl+Alt+ドラッグでのブラシサイズの変更ができない

- [ブラシ系ツール]: 2026-07-02版のVer1系ブラシツールの調整がVer1系以外のブラシ系ツールにも適用される
  (Ver1系以外のブラシ系ツールを調整前と同様に入り抜きに芯が残る描線に戻しました)

- [ブラシ系ツール]: 手ぶれ補正がVer.1方式の場合にスタイラスを検知面から素早く離すとドラッグ状態が維持されたままになる
  (ブラシ系ツールで前回の終点から今回の始点に向かってヒゲが描画される症状の原因でした)

- [画像変形]: 水彩境界が有効な状態でフローターの変形を行うとアクセス違反が発生し、それ以降は動作正常しなくなる

- [キャンバス解像度の変更]: 水彩境界の幅、ハーフトーンの線数、用紙質感の倍率に解像度の変更が反映されない

- [色調補正系フィルタ]: 通常レイヤー以外を対象にできてしまい、適用するとアクセス違反が発生する
  (現在のところ通常レイヤー以外には適用できないのが正しい仕様です)

- [描画系フィルタ] 水彩境界が指定されたレイヤーに輪郭線・ガウスぼかしを適用するとアクセス違反が発生する

その他細かいバグを修正


[変更]

- [選択系ツール]: 選択操作(置き換え、追加、削除等)を指定する設定を追加


--------------------------------------------------------------------------------------------------------------------------------------------
2026-07-12版

[バグ修正]

- [ファイルビューア]: 保存ボタンを押しても保存できないことがある

- [レイヤーマスク]: 水彩筆の描画がおかしい

- [ビュー]: レイヤーリストから非アクティブなビューへ項目をドラッグ＆ドロップしてもコピーされない

- [投げ縄系ツール]: [選択方法]が[多角形]か[多角形+手描き]だとフリーズする

- [投げ縄塗り]: 選択領域が適用されない

- [２値系ブラシ]: [ドラッグ中も色を拾う]がONだとスポイト操作のドラッグで前景色と透明色が激しく入れ替わる

- [ブラシテクスチャ]: [濃淡を反転]をONにすると正しい濃度にならない


[変更]

- [投げ縄選択ツール]: 修飾キーなしでの選択操作を「領域の置き換え」から「領域の追加」に変更

- [筆ツール]: 軽い筆圧でも濃度が出やすいよう初期パラメータを調整
  (久しぶりに初期状態で触ったら腱鞘炎になるわって感じだったので)

- [バケツツール]: 安定版以前の動作にする設定[選択領域を貫通して領域抽出]を追加


--------------------------------------------------------------------------------------------------------------------------------------------
2026-07-11版

[バグ修正]

- [レイヤーリスト]: Ctrl併用でレイヤー項目を複数選択するとスクロール位置が必ずカレントレイヤーに戻る

- [カラーモード変更]: キャンバスの外にはみ出しているレイヤーがあると正常動作しない

- [文字レイヤー]: 一部のフォントが使用されるとメモリ不足エラーが発生する
  (OpenType仕様における'post'テーブルに大量のグリフ名が格納されているフォントで発生していました)

- [投げ縄選択ツール・投げ縄塗りツール]: フリーズが多発する

- [文字ツール]: フローティングビューでのキー入力フォーカスの制御が正常に動作しない

- [ブラシ系ツール]: 左ドラッグ中に右ボタンを押す、またはその逆の動作でマウスキャプチャが解除されない状態になる

- [ブラシ系ツール]: Shift併用の直線描画でガイドが45度単位にスナップされる


--------------------------------------------------------------------------------------------------------------------------------------------
2026-07-08版

[バグ修正]

- [ファイルメニュー]: キャンバスが編集されているかどうか(保存操作ができるかどうか)が[キャンバスを保存]の有効状態に反映されない

- [ファイルメニュー]: [常にファイルビューアを使用]をOFFにしてもシステムファイルダイアログが使用されない

- [クリップボード]: レイヤーフォルダを選択してコピーまたは切り取りを行うとメモリを食い潰してエラーになる

- [レイヤー用紙質感]: レイヤーフォルダに反映されない

- [図形レイヤー]: 大改修前のバージョンで作成したキャンバスを読み込むと図形が透明になる

- [文字レイヤー]: 無効なフォントが使用された場合にアクセス違反が発生するなど正常に動作しない

- [投げ縄ツール]: 選択領域の上からドラッグを開始するとShift/Altを押していても常に選択の解除になる

- [自動選択ツール]: マウスカーソルが大規模改修前と異なる

- [文字ツール]: フォント一覧で名前が空欄になるフォントがある
  (現時点ではCFFフォントに対応していないためそれらのフォントでは名前が空欄になっていました。
  ひとまずフォント名を赤字で表示して無効なフォントとして扱うようにしました)

- [ブラシ系ツール]: 手ぶれ補正がVer.1方式の場合にストロークのヌキが途切れる
- [図形ツール]: 図形を作成すると同じレイヤーが31枚作成される
  (2026-07-06版の軽いタッチでのドラッグの問題の修正でエンバグさせていました)

- [ブラシ系ツール]: ショートカットキーでのブラシサイズ変更でブラシ円が再描画されない

- [画像変形]: 遠近感スライダを操作するとアクセス違反が大量に表示される
  (自分用覚書: SetTimer()で指定するタイマープロシージャの中では例外が発生しても強制終了しない)

- [レイヤー塗り潰し・消去]: レイヤーフォルダに適用できない

- [レイヤー結合]: レイヤー不透明度や特殊効果の調整がレイヤーリストの項目に反映されない

- [キャンバス解像度の変更]: アクセス違反が発生する、変更後の画像にゴミが現れるなど

- [色調補正系フィルタ]: レイヤーフォルダに適用できない

- [最近使用したファイル]: 存在しないパスがあるとメモリリークが発生する


--------------------------------------------------------------------------------------------------------------------------------------------
2026-07-06版

[バグ修正]

- [ツール全般]: ごく軽いタッチでドラッグ操作を繰り返すとドラッグと判定されなくなる場合がある

- [PSD/PSB保存]: レイヤーマスクが存在するキャンバスをPSD/PSBとして保存すると不正なファイルが作成される

- [画像保存ダイアログ]: 横ピクセル数に対して一定以上縦ピクセル数が長いキャンバスで[元の画像]を指定するとアクセス違反が発生する

- [ビュー]: 非アクティブ状態のビューに対するスポイトが動作していない

- [レイヤー用紙質感]: 質感の階調が反転している
  (誤って水彩境界の処理を適用していました)

- [レイヤーマスク]: 塗り潰しや消去が常に親レイヤーに対して適用される

- [投げ縄選択ツール・投げ縄塗りツール]: アンチエイリアスOFFを指定してもアンチエイリアスが適用される

- [投げ縄塗りツール]: 透明色で閉領域塗り潰しを行うとフリーズする

- [効果ペン]: グレースケールモードで使用すると不正な色値で描画される

- [ペン入れレイヤー:色変更ツール]: ストロークへの色変更が適用されない
  (図形レイヤー用の処理と分けるのを忘れていました)

- [画像変形]: 水彩境界が有効だと確定時にアクセス違反が発生して失敗する

- [キャンバス解像度の変更]: 変更前後のサイズの組み合わせによってはアクセス違反が発生して失敗する

- [設定ダイアログ]: [設定]ダイアログの[ペンタブレット]ページの[最小筆圧]が[WinTab APIを使用する]と[Windows APIを使用する]に反映されない。

- [設定ダイアログ]: [動作環境]の[ヒストリおよび作業復元用データ、画像ファイルのサムネールの格納先]の変更が次回起動時に反映されない


[その他]
本テキストの2026-07-02版の節の[その他変更箇所]にレイヤー数上限についての記述を追加しました。


--------------------------------------------------------------------------------------------------------------------------------------------
2026-07-05版

[バグ修正]

- [キャンバス]: キャンバスの作成を伴う操作でエラーがポップアップする環境がある
  (ICCプロファイル関連のAPIの仕様の読み違えによるミスが原因でした)

- [PSD/PSB保存]: レイヤーフォルダが存在するキャンバスをPSD/PSBとして保存すると不正なファイルが作成される

- [PSD/PSB読込]: レイヤーフォルダの終端情報に色成分の識別情報が存在しない場合「対応していない成分構成です」と表示され読み込めない

- [画像保存ダイアログ]: 選択領域が色で表示されている時に画像保存ダイアログが表示されるとアクセス違反が発生する
  (Visual C++のバグにより不正なコードが生成されていました)

- [定規]: 定規のリセットが動作しない

- [HSV/HSLスライダ]: H値が更新されない

- [ブラシ系ツール]: ドットカーソルを設定してもドットカーソルにならない

- [フルスクリーンモード]: 通常モードとフルスクリーンモードを切り替えると画面の一部が乱れる

- [設定ダイアログ]: [動作環境]の[ヒストリおよび作業復元用データ、画像ファイルのサムネールの格納先]で存在しないパスを指定できない


--------------------------------------------------------------------------------------------------------------------------------------------
2026-07-04版

[バグ修正]

- [キャンバス]: キャンバスの作成を伴う操作がエラーにより失敗する
  (モニタのICCプロファイルを利用できない環境だとこの問題が発生するようです。
  このバージョンでは情報収集のためモニタのICCプロファイルのエラーについてすべてポップアップで報告します。
  キャンバス作成を伴う処理でエラーポップアップが表示されましたらお手数でなければエラーログをご提供いただけると助かります)

- [JPEG形式]: JPEGファイルを開くことができない

- [選択消し]: [選択ペン]と同じ動作になって選択を消せない

- [編集メニュー]: 貼り付け系の操作が動作しない
- [ブラシ系ツール]: サイズ変更や濃度変更のショートカットキーが動作しない
- [図形系レイヤー]: [選択]メニューの[制御点の選択の解除]が動作しない
  (すみません、ただ作り忘れていました)

- [英語版]: 一部のテキストが翻訳されていない

ひとまずすぐに直せる中で早急に対処するべき問題を修正しました。
上記以外の問題の修正はもう少し時間をいただきます。


--------------------------------------------------------------------------------------------------------------------------------------------
2026-07-02b版

[バグ修正]

- [ライセンス]: 大多数のライセンス証明書が正しく認識されない。


--------------------------------------------------------------------------------------------------------------------------------------------
2026-07-02版

大規模改修版をリリース

--------------------------------------------------
■ 注意事項 (2026/07/08追記)
--------------------------------------------------

この大規模改修版版以降で作成された下記のデータは過去のバージョンで使用できなくなります。
・編集作業の復元データ
・ショートカットキーの設定 (過去のバージョンとは別の設定データとして保存されます)

この大規模改修版版から対応OSがWindows Vista以降、SSE 4.1を搭載したCPUが必須となります。


--------------------------------------------------
■ 作り直した機能
--------------------------------------------------

[ファイルビューア]
 ・表示内容の更新を非同期処理化
 　(操作を受け付けなくなることが少なくなります)
 ・サムネール更新を高速化
 ・ファイルシステムAPIのみで閲覧する機能を追加
 　([設定]ダイアログの[動作詳細]ページの[ファイルビューア]節で指定できます)

[ビュー]
 ・操作の応答性を向上
 ・安定化

[投げ縄ツール]
 ・閉じた領域のみを選択する機能を追加

[自動選択ツール]
 ・漏れ出し防止のアルゴリズムを刷新

  (以前の方式は新設した閉領域選択と相性が悪かったため変更が必要でした。 新しい方式は細かく入り組んだ形状が苦手ですが、整った線画なら以前より良い結果になると思います)

[文字ツール]
 ・字間・行間などの調整機能を追加
 ・ルビ機能を追加
 ・縦中横機能を追加
 ・アラビア語などの双方向用字体系に対応
 ・画像変形に対応 (但し拡大縮小・せん断・回転のみ)
  (フォントドライバを自前で実装したので現状では安定性に不安があります(壊れたフォントファイルへの耐障害性など))
  (可変フォント、CFFフォントには対応していません)
  (インド用字体系にはまだ対応していません)

[画像変形]
 ・格子変形(２次ベジェ曲面)とメッシュ変形(スプライン曲面)を実装
 ・対称定規有効時の対称変形を実装
 　(１分割・線対称なしの対称定規を有効にして回転させると変形元の範囲の回転に応用できます)


--------------------------------------------------
■ 新規追加された機能
--------------------------------------------------

[グレースケールモード]
 ・キャンバス作成時にカラーモードとして選択可能
 ・[キャンバス]メニューの[カラーモード]で変更可能

[簡素なカラーマネジメント]
 ・カラー画像にはsRGB、グレースケール画像にはsGrayのICCプロファイルを適用する機能を追加
 ・読み込んだ画像のICCプロファイルはそのまま維持
  (ひとまずの実装です。将来機能を強化する予定です)

[ウィンドウの配色の変更]
 ・白色系と暗色系の配色を選択可能
  ([ウィンドウ]メニューの[ウィンドウの配色]から変更できます)

[用紙グリッド]
 ・間隔と上下左右のマージンを指定可能
 ・ブラシ描画・図形編集・画像変形の操作をスナップすることが可能

  (レイヤー操作パネルの定規系レイヤー作成メニューから作成できます)

[２値ハーフトーン]
 ・形状と線数と角度を指定可能
 ・形状は円、砂目、菱形、楕円、直線、四角、十字
  (レイヤーの特殊効果として選択できます)

[投げ縄塗りツール]
  (投げ縄選択ツールの塗り潰し版です。ツール欄には自動的に追加されませんのでツール作成メニューから手動で作成してください)

[素材登録機能]
 ・キャンバス画像をレイヤー用紙質感、ブラシ形状、散布画像、ブラシテクスチャとして登録する機能を追加
　 (それぞれの素材の選択ポップアップの下端に追加ボタンがあります)


--------------------------------------------------
■ その他変更箇所
--------------------------------------------------

[レイヤー管理] (2026-07-06追記)
・レイヤー数の上限を撤廃

[レイヤーマスク] (2026-07-31追記)
・レイヤーとレイヤーマスクの同時操作を実装
  (切り取り・コピー・画像変形に適用されます。レイヤーとレイヤーマスクを個別に操作したい場合は下記の操作を行ってください。
  - レイヤーマスクの移動リンクをOFFにする
  - レイヤーリスト上でAltを押しながらレイヤーまたはレイヤーマスクのサムネールをクリックして青枠を付けた状態にする)

[指定したファイル形式で出力]
 ・保存時の画像サイズ変更を実装
 ・SAI2、PSD、JPEG形式以外はピクセルフォーマットを指定可能

[カラーサークル]
 ・サイズ変更できるよう変更

[散布ツール]
 ・複数画像を使用できるよう変更
 ・カラー画像を使用できるよう変更
  (複数画像はグループごとに散布設定を変更できるようにしました。グループは最大３つ、[素材・ツールの管理]ダイアログで編集できます)

[ペン入れ・図形レイヤー]
 ・曲線の曲率の品質を向上 ・通常レイヤーと同様に選択領域での切り取り・コピーができるよう変更
 ・パスの向きが分かるよう最初と最後の制御点を三角矢印に変更

[図形レイヤー]
 ・図形に輪郭線を付ける機能を追加
 　(曲線ツール、折線ツール、図形変更ツールで指定可能)
 ・折れ線の角を落とす機能を追加
 　(曲線ツール、折線ツール、角落としツール、図形変更ツールで指定可能)
 ・図形間でパスを移管する機能を追加
 　(Shift+Ctrlを押しながら制御点を他の図形の曲線部分か塗り部分にドラッグ)
   (パスの向きの反転と重ね合わせ順序の変更の機能を追加するのを忘れていました…)

[定規]
 ・用紙グリッドかパースグリッドが有効な状態で定規を表示するとグリッドにスナップされるよう変更
 　(定規の配置は用紙グリッドまたはパースグリッドに記憶されます)

[ショートカットキーの割り当て]
 ・シフト操作のON/OFFを個別に指定できるよう変更 (シフト操作に対応した機能のみ)


他にもあるような気がしますが思い出せません、すみません…


--------------------------------------------------------------------------------------------------------------------------------------------
2026-07-02版

大規模改修前の最後の安定版です。

[バグ修正]

- [新規ツール作成]: "Ver.1風"で"ぼかし"を作成すると水彩筆ベースのツールではなくVer.2で新設されたぼかしツールが作成される
  (初期化時に作成される"ぼかし"はVer.1と同じ水彩筆ベースのツールになっていますが、それと同じツールを新規作成することができないということです)

- [ブラシ系ツール]: Ver.1系ブラシツールで線幅が 1.0 付近の場合の描線がVer.1より若干細い

- [グラデーションツール] ツールシフトでグラデーションツールを使用して確定・キャンセルすると正常動作しなくなる


[変更]

- [設定ファイル]: 設定ファイルの破損を検出した際の復元処理を改良

- [設定ダイアログ]: [CPUコアの割り当て方]の[A. システムの負荷がない状態なら応答性が最速になるようにCPUコアを割り当てる]を廃止
  (Windows 11でシステム自身がCPU負荷をかけ続けていると見られる症状の報告が相次いだためです)

- [ツール動作詳細] 2019-08-12版以前のブラシの操作パネル内に埋め込まれた形式に再変更
  (パラメータが大きく増えることを見越して変更したつもりでしたが数点の追加で済むと分かったため元に戻しました)


その他細かい調整とバグ修正


--------------------------------------------------------------------------------------------------------------------------------------------
2024-11-23版

[バグ修正]

- [初期化]: 設定ファイル内の[ヒストリおよび作業復元データ、画像ファイルのサムネールの格納先]が無効なパスになっているとエラーで起動できない
  (他のPCから設定ファイルをコピーした場合などに起こり得ます)


[変更]

- [設定ダイアログ]: [CPUコアの割り当て方]の具体的な調整方法の説明を追加

- [ヒストリ]: 各キャンバスのヒストリと復元データの格納先に「__<キャンバスのファイル名>.txt」という名前のファイルを作成するよう変更
  (ファイルの内容はキャンバスのフルパスです)


その他細かい修正


--------------------------------------------------------------------------------------------------------------------------------------------
2024-08-14版

[バグ修正]

- [ウィンドウ制御]: 修飾キー併用ショートカットキーで時間がかかる処理を行うと修飾キーが押しっぱなしの状態になる場合がある

- [ブラシ系ツール]: [ブラシ円を描画時の実際のサイズで表示する]がONの場合に最小サイズの筆圧を無効にしても最小サイズの円が表示され続ける


--------------------------------------------------------------------------------------------------------------------------------------------
2024-07-19版

[バグ修正]

- [２値系ブラシ]: 対称定規が有効だと描き始めの１ピクセルが描画されない

- [ファイルビューア]: ファイル一覧上のフォルダのショートカットにファイルをドラッグするとsai2.exeのあるフォルダに移動・コピーされる

- [ウィンドウ制御]: 時間がかかる処理(巨大なファイルの保存・読込等)を行うとウィンドウがブラックアウトする場合がある


--------------------------------------------------------------------------------------------------------------------------------------------
2024-05-22版

[バグ修正]

- [対称定規]: ２値系ブラシによる描画が完全な対称にならない

- [ファイルビューア]: サムネールのキャッシュファイルが破損している場合にアクセス違反が発生する

- [ペンタブレット制御]: ペンタブレット制御APIが Windows API の場合のペンによるドラッグ開始時の引っかかりの抑制が機能していない


[変更]

- [２値ペン]: レイヤーマスクに描画する際の描画色の扱い方を他のブラシ系ツールと同じ動作に変更

- [ファイルビューア]: [すべてのサムネールを更新]を実行する際にサムネールのキャッシュファイルを一旦削除するよう変更


その他細かい修正


--------------------------------------------------------------------------------------------------------------------------------------------
2024-04-10版

[バグ修正]

- [ペンタブレット制御]: ペンタブレット制御APIが Windows API だとポップアップメニューやドロップダウンリストが操作できない


--------------------------------------------------------------------------------------------------------------------------------------------
2024-04-07版

[バグ修正]

- [ペンタブレット制御]: ペンタブレット制御APIが WinTab API だとSAIをアクティブ化した際に操作不能に陥る場合がある

- [設定ダイアログ]: [環境]ページの[CPUの割り当て方]の設定が正しく動作しない

- [ファイルビューア]: ファイルリスト上で左クリックの後すぐに右クリックするとダブルクリックになる


[変更]

- [設定ダイアログ]: [環境]ページの[CPUの割り当て方]に使用するCPUコア数を減らせる設定を追加
  (但し、その設定は処理速度が大幅に低下する可能性があります。どうやっても動作遅延が解消できない場合の最後の手段として用意しました)

- [レイヤー選択]: カレントレイヤー選択のショートカットを最後にマウスで選択した要素(レイヤーorレイヤーマスク)を優先するよう変更

- [ショートカットキーの割り当て]: [レイヤー設定]グループに[レイヤーマスクを選択・解除]を追加


--------------------------------------------------------------------------------------------------------------------------------------------
2024-02-22版

[バグ修正]

- [素材選択リスト]: グループ数が15を超えるとグループ欄のレイアウトが崩れる

- [素材選択リスト]: 一度でもスクロールバーを操作するとグループ切り替え時に素材サムネールが直ちに更新されなくなる

- [パースグリッド]: パースグリッドを１点パース定規の軸平面に配置できてしまい操作不能になる

- [ウィンドウ制御]: ウィンドウをアクティブ化する際に初回のクリックが無視されない
  (2023-11-20版でエンバグさせていました)

- [ポップアップリスト]: スクロールバーを操作してからリスト外をクリックしてキャンセルしようとするとクリックが一回無視される
  (正しく修正できていなかったので再修正しました)


[変更]

- [レイヤーマスク]: レイヤーマスクが設定されたレイヤーフォルダを選択した際にレイヤーマスクが優先的に選択されないよう変更

- [ブリスル]: 毛点が63点を超えているブリスルを選択した際にエラーを表示して使用不可とするよう変更

- [曲線ツール・折線ツール]: 対称定規が適用されるよう変更

- [ファイルビューア]: 正常に情報を取得できないシェル名前空間項目を無視してファイルビューアが動作不能にならないよう変更


その他細かい修正


--------------------------------------------------------------------------------------------------------------------------------------------
2023-11-20版

[バグ修正]

- [スレッド間通信]: 一部の機能の通信で稀にメモリ破壊やアクセス違反が発生する

- [二値消し]: [ピクセル不透明度の保護]が適用されない

- [スポイト]: レイヤーリスト上でのレイヤーマスク使用のON/OFFが無視される

- [設定ダイアログ]: [環境]ページの[プロセスの実行優先順位]節を刷新
  ([CPUの割り当て方]の設定を追加して、それに伴い節の名称を[プログラムの応答性が悪い場合の対処]に変更して説明文を修正しました)

- [ポップアップリスト]: スクロールバーを操作してからリスト外をクリックしてキャンセルしようとするとクリックが一回無視される


[変更]

- [メニューバー]: 表示しきれなかった項目をアクセスキーで開けるように変更


その他細かい修正


--------------------------------------------------------------------------------------------------------------------------------------------
2023-07-11版

[バグ修正]

- [図形系レイヤー]: 復元ポイントの作成時にごく稀に図形の重ね合わせ順序が誤って記録される場合がある

- [設定ダイアログ]: [ヒストリおよび作業復元データ、画像ファイルのサムネールの格納先]で空文字列を指定できてしまう


[変更]

- [消失点・対称定規]: Shift+Ctrlで移動操作に入れるよう変更


--------------------------------------------------------------------------------------------------------------------------------------------
2023-04-05版

[変更]

- [マルチコア処理]: CPUの割り当て方を修正


--------------------------------------------------------------------------------------------------------------------------------------------
2023-04-02版

[バグ修正]

- [修正液ツール]: 消去対象が複数レイヤーの場合に不可視のペン入れレイヤーも消去される

- [ベクトル画像全般]: 文字レイヤーや定規などの輪郭の一部にゴミが乗る

- [ビュー]: 50%以下に縮小すると拡大縮小の中心がずれる

- [フィルタ：ガウスぼかし]: レイヤーマスクへの適用結果が正しくない


[変更]

- [拡大鏡ツール]: スクラブズームのドラッグ方向を左右から上下に変更する設定を追加

- [対称定規]: 定規の中心の位置揃えをピクセル中心かピクセル境界で選べるよう変更
  (対称定規のコンテキストメニュー(Ctrl + 分割線を右クリック)から指定できます)


--------------------------------------------------------------------------------------------------------------------------------------------
2022-12-01版

[バグ修正]

- [素材・ツールの管理]: スクラッチパッドのリネームができない

- [レイヤーパネル]: レイヤー項目を上段のボタンにドラッグした場合にマウスカーソルがボタンから外れた時点でドラッグがキャンセルされてしまう

- [集中線定規]: 定規移動の当たり判定の範囲が表示倍率に応じて変化してしまう


--------------------------------------------------------------------------------------------------------------------------------------------
2022-08-28版

[バグ修正]

- [文字レイヤー]: キャンバス外で編集を行うとアクセス違反が発生する場合がある

- [文字レイヤー]: キャンバス外のレンダリングが欠ける場合がある

- [ヒストリ]: 編集操作の直後にキャンバスを閉じるとアクセス違反が発生する場合がある


--------------------------------------------------------------------------------------------------------------------------------------------
2022-05-27版

[バグ修正]

- [定規類]: ペンタブレット制御が[Windows APIを使用する]になっている場合にカーソルとガイド線の移動が遅くなる場合がある

- [指先ツール]: プログラムを起動し直すと[着色]チェックボックスがOFFになる

- [画像変形]: キャンバスサイズが 32768×32768 を超えた部分の画像が作成されない

- [直線系定規]: 定規移動の当たり判定が高DPI環境でも96ppi時の範囲になっている


--------------------------------------------------------------------------------------------------------------------------------------------
2022-02-07版

[バグ修正]

- [メニュー・ポップアップリスト]: Windows 7以前の環境でメニューやポップアップリストをクリックで閉じることができない

- [境界線の描画]: [位置]が[内側]で範囲の端が32pix境界に揃っていると正しく境界線が描画されない

- [画像変形]: ナッジ・左右反転・90度回転がガイドを回転した後の角度で適用される


[変更]

- [定規類]: [一時的に定規を無効化]をONにすると定規の操作ができないように変更
  (定規無効化時にブラシ系ツールのShift+クリックでの直線描画を使えるようにする措置です)


--------------------------------------------------------------------------------------------------------------------------------------------
2022-01-05版

[バグ修正]

- [水彩筆]: Ver.1と比較してぼかしが滑らかすぎていたのを修正

- [筆系ツール]: 2021-12-30版の修正により混色の程度が若干強くなっていたのを修正


--------------------------------------------------------------------------------------------------------------------------------------------
2021-12-30版

[バグ修正]

- [ウィンドウ制御]: Windows 8以降でタイトルバーから開いたシステムメニューの[移動]と[サイズ変更]が機能しない

- [ツールグループ]: 一旦[未整理]グループを選択した状態でプログラムを終了するとそれ以降の起動時のグループ選択が[未整理]に固定される

- [水彩筆]: Ver.1と比較してぼかしが平坦になりすぎていたのを修正

- [筆系ツール]: 軽い筆圧での淡い描画が制御しにくい傾向があったのを修正

- [パス編集ツール]: 複数パス選択時にパスの連結(Shift+Ctrl+制御点間ドラッグ)を行うと回復不可能な誤作動が起きる


[変更]

- [編集メニュー]: [選択領域を解除せずに貼り付け]を追加


--------------------------------------------------------------------------------------------------------------------------------------------
2021-10-06版

[バグ修正]

- [ブラシ系ツール] ペンタブレット使用時にブラシ円・ガイド線が遅延する

- [カラーパレット・スクラッチパッド] 色を拾うとアクセス違反が発生する


--------------------------------------------------------------------------------------------------------------------------------------------
2021-10-05版

開発環境の移行によりこのバージョンからWindows 2000はサポートされなくなりました。

[バグ修正]

- [色履歴] 登録された色が元の色と若干異なる

- [選択領域] レイヤーサムネールのクリックで選択領域を作成すると縦筋状のゴミが現れる

- [スポイト] ショートカットキーでのスポイトがスクラッチパッド上で動作しない

- [カスタムツール] ツールとそのリンクをすべて削除するとプログラムの終了時にアクセス違反やフリーズが発生する

- [ブラシ系ツール] [ブラシ円を手振れ補正後の位置に表示する]が ON の場合に定規を表示するとブラシ円・ガイド線・ストロークの遅延が発生する


[変更]

- [ツール設定の読み込み] ツール設定の保存先フォルダに不正な名前の設定ファイルが存在していてもエラーとして報告しないよう変更
  (OneDrive の同期が失敗した際に同じフォルダにバックアップファイルを作成する仕様への対策)

- [ブラシ系ツール] 手ぶれ補正が S-1～S-7 の場合のストロークのヌキを再調整


--------------------------------------------------------------------------------------------------------------------------------------------
2021-07-06版

[バグ修正]

- [ショートカットキーの割り当て] ツールとツールグループへのキー割り当て機能が直ちに反映されない


[変更]

- [移動ツール] [修飾キーなしでレイヤー選択]の設定を追加
  (2021-07-03版での修正を適用するかどうかの設定です)


--------------------------------------------------------------------------------------------------------------------------------------------
2021-07-03版

[バグ修正]

- [ヒストリ] キャンバス外のレイヤー画像を消去した直後にブラシ描画を行うと稀にアクセス違反が発生する場合がある
  (キャンバス外を消去→復元ポイント作成開始→復元ポイント作成完了前にブラシ描画という処理が行われると発生します)

- [ブラシ系ツール] 操作パネルを隠した状態でプログラムを起動するとブラシ形状やテクスチャが反映されない

- [ブラシ系ツール] [ブラシ円を手振れ補正後の位置に表示する]が ON の場合に素早いストロークの後にペンを止めるとブラシ円が更新されない

- [移動ツール] [Ctrl+左クリックでレイヤー選択]が ON の場合に移動ツール限定のCtrlなしの選択ができなくなっている

- [PSD形式] レイヤーフォルダの終端情報に問題があり一部環境(ImageMagick等)でエラーが発生して読み込めない


[変更]

- [ツール] ショートカットキーによるツール選択が同じショートカットキーが割り当てられたツールを循環するよう変更

- [ツールグループ] ショートカットキーでツールグループを選択できるように変更

- [ショートカットキーの割り当て] ツールグループを含めたツールへのキー割り当て機能を復活


--------------------------------------------------------------------------------------------------------------------------------------------
2021-05-28版

[バグ修正]

- [レイヤー単独表示] クリッピンググループの子のレイヤーを単独表示にすると不可視になってしまう

- [作業の復元] [作業の復元]を開いた後やプログラムの終了時にごく稀にアクセス違反が発生する場合がある


--------------------------------------------------------------------------------------------------------------------------------------------
2021-02-28版

[バグ修正]

- [ぼかしツール] 散布形状やツール動作詳細の設定が保存されない

- [ファイルビューア] フォルダツリー上でカレントフォルダを削除した後にファイルリストをキー操作するとアクセス違反が発生する


[変更]

- [レイヤー単独表示] 単独表示している階層より下のレイヤーについての可視状態変更操作を単独表示解除から通常の可視状態変更に変更
  (2020-08-28版の更新履歴でのこの変更の記載は誤りでした)

- [PSD形式] 「背景」が単色の場合は[背景]レイヤーを作らず[キャンバスの背景]に変換するよう変更

- [ペン入れレイヤー] ２値ストロークの移動操作をピクセル単位で移動するよう変更


--------------------------------------------------------------------------------------------------------------------------------------------
2020-11-28版

[バグ修正]

- [筆系ツール] 対称定規が有効な場合にストロークが交差した部分の濃度がおかしい

- [２値ペン・２値消し] 描画方式が反映されない

- [設定の引継ぎ] Ver.1のペン入れレイヤー用ツールを正しく引き継ぎできない


[変更]

- [ブリスル] 25%以下の表示倍率で大径ブリスルを使用した際の方向確定までの距離が長くなりすぎていたのを調整

- [ペン入れレイヤー] ２値ストロークの最初の制御点を移動した際にストローク全体が振動するのを軽減


--------------------------------------------------------------------------------------------------------------------------------------------
2020-08-28版

[バグ修正]

- [ブラシ系ツール] 手振れ補正を強めに設定して描画している際にペンを止めるとストロークがペン位置まで追従しない
  (ストローク歪み補正の影響でしたので補正条件を変更しました)

- [ブリスル] 小径ブラシのブラシテクスチャの効果に斑が出る

- [消しゴム] プロパティに手振れ補正の設定が表示されない

- [修正液ツール] ブラシサイズ1.0未満で保存しても1.0に戻される

- [修正液系ツール] ベクター化に関するパラメータが保存されない

- [修正液系ツール] 筆圧制御点の作成OFFで消去を行うと時々既存の筆圧制御点が不正な位置になりキャンバス読み込み時にエラーが報告される

- [ファイルビューア] ジャンクションの第一階層を保存先に選択できない

- [素材・ツールの管理] ツール以外の素材を削除するとアクセス違反が発生する

- [ペンタブレット制御] [Widnows API]モードだと操作パネル等を操作してからビューに戻っての一筆目で筆圧感知がされない

- [ペンタブレット制御] サイドスイッチに割り当てたテールスイッチでのドラッグ中にツールの選択等がブロックされない


[変更]

- [レイヤー単独表示] 単独表示している階層より下のレイヤーについての可視状態変更操作を単独表示解除から通常の可視状態変更に変更

- [修正液系ツール] [交点の検出元]の初期値を[消去対象]に変更


--------------------------------------------------------------------------------------------------------------------------------------------
2020-06-17版

[バグ修正]

- [ブラシ系ツール] ブラシ形状の方向検出モードが[自動]の場合にごく短いストロークを描こうとすると筆圧が不自然に強くなる

- [ユーザーパレット] 項目サイズの変更が保存されない

- [レイヤー単独表示] [レイヤーの可視状態を変更]のショートカットで単独表示が解除されない


[変更]

- [ブラシ系ツール] ブラシ形状の方向検出モードが[自動]の場合に叩くような短いタッチでも描画がされるよう変更

- [レイヤー操作パネル] 親階層のレイヤーが不可視であっても[下のレイヤーでクリッピング]が無効状態にならない変更


その他細かいバグ修正


--------------------------------------------------------------------------------------------------------------------------------------------
2020-05-10版

[バグ修正]

- [設定保存] SAIv2の実行中にPCのシャットダウンやサインアウトをキャンセルするとアクセス違反が発生する

- [素材・ツールの管理] グループの削除と作成を行いダイアログを閉じるとアクセス違反が発生することがある

- [ブラシ系ツール] ストロークの末尾が従来のバージョンよりペンデータ１つ分長い

- [ぼかしツール] [ぼかし幅]の設定が保存されない

- [画像変形] 画像変形中に変更した「ピクセルの再計算方法」が保存されない


[変更]

- [カスタムツール作成メニュー] [既存ツール]タブの[移動]ボタンを廃止


その他細かい調整とバグ修正


--------------------------------------------------------------------------------------------------------------------------------------------
2020-04-10版

[バグ修正]

- [Ver.1からの設定の引継ぎ] 設定の引継ぎを行った後のVer.2を終了せずにVer.1を起動するとユーザーパレット等の読み込みに失敗して空になる
  (Ver.1への影響です。Ver.1とVer.2の双方を終了させてからVer.1を起動すると復活します)

- [レイヤーリスト] 最下端までスクロールしていてかつ余白がある場合にカレントレイヤーを切り替えるなどする度にリストが少しずつズリ下がる

- [ブラシ系ツール] ブラシサイズを500以上しても次にSAIを起動したとき500になる

- [ブラシ系ツール] ツールを複製した際に[手ぶれ補正方式]がリセットされる

- [ブラシ系ツール] ブリスルのイリが最小サイズを０にしても若干太い

- [ペン入れレイヤー] 制御点を選択できなくなる場合がある
  (制御点を移動させようとすると制御点の追加移動になってしまう症状の原因はこれでした)

- [ウィンドウ制御] ファイルビューアを表示している際にデスクトップの解像度を変更するとフリーズする
  (ひとまずフリーズが起きないよう暫定的な修正を行いました。今後正式に修正します)

- [マルチコア処理] 論理CPU数が32以上だと正常動作しない


[変更]

- [ブラシ系ツール] 小径ブラシにおけるテクスチャの効果がより自然になるよう調整

- [ブラシ系ツール] ブリスルの描画をよりVer.1に近付くよう調整

- [ブラシ系ツール] 2020-01-19版でのストローク歪みに関する修正を無効にする設定を sai2.ini に追加
  ([PenTablet] -> DisableAntiStrokeDistortion)


その他細かい調整とバグ修正


--------------------------------------------------------------------------------------------------------------------------------------------
2020-01-25版

[バグ修正]

- [旧Ver.2からの設定の引継ぎ] "brshape"フォルダや"scatter"フォルダが無いバージョンからの引継ぎがエラーで失敗する

- [２値線変更ツール] 全く動作しない

- [フィルタ：ガウスぼかし] フローターを作成した状態でガウスぼかしを開始してキャンセルすると内部情報が破壊されアクセス違反が発生する。

- [規定サイズの編集] スクロールされた状態だと規定サイズ一覧の順序変更が正しく動作しない

- [素材・ツールの管理] スクロールされた状態だとグループ一覧および項目一覧の順序変更が正しく動作しない


--------------------------------------------------------------------------------------------------------------------------------------------
2020-01-19版

[バグ修正]

- [共通ツールのプロパティ] ショートカットキーの設定変更が保存されない

- [ツール選択] ドラッグ操作中のツールシフトが禁止されていない
  (どこかのバージョンでエンバグさせてしまっていたようです)

- [ブラシ系ツール] 手ぶれ補正が[Ver.1方式]の場合のストロークのヌキが甘い

- [ブラシ系ツール] ペンタブレットのパケットの受信間隔が不均一になる部分でストロークが歪む

- [ぼかしツール] ブラシ形状とテクスチャの設定が保存されない

- [設定ダイアログ] キャンバスを作成していない状態で[レイヤー合成モードをSAIでの方言ではない一般的な名称で表示する]を
  変更するとアクセス違反が発生する


--------------------------------------------------------------------------------------------------------------------------------------------
2020-01-13版

[バグ修正]

- [画像素材] 素材選択リストで極端に細長い画像が表示されるとアクセス違反が発生する

- [素材・ツールの管理] [未整理]グループ内の素材の順序変更が保存されない

- [ショートカットキーの割り当て] 変更が反映されない


[変更]

- [設定の引継ぎ] ダイアログ上の文面に引継ぎ可能なSAIのバージョンの範囲を追記
  (Ver.1 は Ver.1.0.2以降、Ver.2 は 2015-04-24 から 2019-08-12 まで)

- [素材・ツールの管理] ユーザーパレットとスクラッチパッドの名前変更と削除を実装

- [素材・ツールの管理] ツールに関する操作を実装
  (グループの作成・削除・名前変更・並べ替え、ツールの削除・並べ替え・グループ間移動)


--------------------------------------------------------------------------------------------------------------------------------------------
2020-01-08版

[バグ修正]

- [散布ツール] 形状が[通常の円形]の散布ツールを選択する度に散布に関するパラメータがリセットされる

- [ツール] バケツかグラデーションツールをコピーするとアクセス違反が発生する

- [設定の引継ぎ] キャンバスの規定サイズが正しく引継がれない

- [ヒストリ] レイヤーマスク、テキストレイヤー、定規系レイヤー、レイヤーフォルダの一部のデータが復元されない


その他細かいバグ修正


--------------------------------------------------------------------------------------------------------------------------------------------
2020-01-07c版

[バグ修正]

- [ペン入れレイヤー] 制御点が１つだけのストロークを描画するとアクセス違反が発生する

- [線変更ツール] ストロークのパラメータがすべてクリアされてしまう

- [２値系ブラシツール] 筆圧がブラシサイズに反映されない


--------------------------------------------------------------------------------------------------------------------------------------------
2020-01-07b版

[バグ修正]

- [設定の引継ぎ] 旧Ver.2からのツール設定の引継ぎが正しく動作していない

- [ペン入れレイヤー] 何かを描画するとアクセス違反が発生する


[変更]

- [ツールパネル] [ツール動作詳細]や設定保存のボタンの並びを変更


--------------------------------------------------------------------------------------------------------------------------------------------
2020-01-07版

※ 注意！ : この進捗報告版以降で作成された編集作業の復元データはこれより過去の進捗報告版では復元できません。

このバージョンから設定ファイルの保存先が "<(マイ)ドキュメント>\SYSTEMAX Software Development\SAIv2" に変更されました。
ブラシ形状やテクスチャなどもそちらに格納されます。

また、配布用ZIPファイルの主構造が下記のように変更されました。
従来のバージョンとはフォルダ構造の互換性がありませんのでご注意ください。

  +init
    +blotmap
    +bristle
    +brshape
    +brushtex
    +papertex
    +scatter
   sai2.exe
   sai2.ini


[新機能]

- 過去のバージョンの設定の引継ぎ
  (SAIv2(2020-01-07版以降)の起動時に過去のバージョンのSAIが検出されてかつ設定の格納フォルダが存在しない場合に
  設定引継ぎのダイアログが表示されます)

- ツール設定の保存・復元機能
  (ツールパネル最下段の左寄りのボタン)

- ツールのグループ分け

- ブラシ形状・テクスチャのグループ分け

- 素材管理ダイアログ(暫定実装)
  (現時点では、グループの作成・削除・名前変更、素材項目の並べ替え・グループ間移動、のみ)

- ぼかしツール

- ２値の各種ブラシ系ツール
　・通常レイヤー用として「２値ペン」「消しゴム」「選択ペン」「選択消し」を追加
　　(従来の「２値ペン」は「ドット絵ペン」に名称を変更しました)

　・ペン入れレイヤー用として「ペン入れ」「修正液」「曲線」「直線」「線変更」を追加

- 色履歴
  (ユーザーパレットと同じ区画内に実装)


[バグ修正]

- [ブラシ系ツール] 以前のバージョンより筆圧による濃淡を制御し難い

- [ブラシ系ツール] 手ブレ補正を上げるとストロークの先頭付近に歪みが起こる

- [筆系ツール] 混色に強い斑ができる
　(2019-08-07版からエンバグさせていました)

- [輪郭線を描く][膨張・収縮] 画像が完全にキャンバス外にあるとアクセス違反が発生する


[変更]

- [ブラシ系ツール] [その他]の区画を[ツール動作詳細]として分離したパネルで表示するよう変更
  (ツールパネル最下段の右端のボタンでON/OFFします。手ぶれ補正の設定はVer.1同様にプロパティダイアログの方へ移しました)

- [ブラシ系ツール] にじみ形状を指定した小径ブラシ(0～6px程度)の線質を再度調整

- [ブラシ系ツール] ブラシ系ツール個別に手ブレ補正の方式を指定できるよう変更
　([設定]の[動作詳細]の[手ぶれ補正 1～15 でのブラシストロークをVer.1と同じ感触にする]をツール個別でも指定できるようにしました)

- [ブラシ系ツール] 透明色での描画時に[水分量]が０の場合の特別処理を廃止

- [ブラシ系ツール] ブリスルの描画品質を調整

- [ブラシ系ツール] ブラシテクスチャの[かすれ]をスライダで強弱を調整する形に変更

- [ショートカットキーの割り当て] ツールに関するショートカットキーの割り当て機能を一旦廃止
  (ツールのグループ分け機能の導入でショートカットキー割り当ての見た目が酷い事になってしまったので仕様を見直します)


その他細かい調整とバグ修正


--------------------------------------------------------------------------------------------------------------------------------------------
2019-08-12版

[バグ修正]

- [対称定規] [対称写像を実図形に変換]ですべての写像を正しく実図形に変換できない

- [投げ縄ツール] 多角形選択で三角形を作れない

- [PSDファイル] ５階層より深いフォルダ構造を含むPSDファイルがエラーで読み込めない
  (PSDファイルの非公開の仕様に基づいて修正したため正しく動作するかどうか分かりません)


--------------------------------------------------------------------------------------------------------------------------------------------
2019-08-07版

[バグ修正]

- [マーカー] (32bit版のみ) 正しく描画されない

- [対称定規] ２分割以上にして対称定規を回転させると点対称側の描画の角度がずれる

- [対称定規] 散布の[散布]パラメータの影響が対称になっていない

- [対称定規] 指先ツールでブラシテクスチャを指定して描画するとアクセス違反が発生する

- [パース定規] １点および２点パース定規で赤消失点の検出指定のボタンが無効化される

- [ペン入れレイヤー] ストロークが正しくレンダリングされない


[変更]

- [対称定規] 線対称描画時にブリスルや散布の形状も線対称になるよう変更

- [ペン入れレイヤー] 複数ストロークの一括操作時のレンダリング速度を改善


--------------------------------------------------------------------------------------------------------------------------------------------
2019-07-29版

[バグ修正]

- [スクラッチパッド] スクラッチパッドの保存ファイルが存在しない場合にエラーにより起動できない

- [ペン入れレイヤー] SAI2ファイルを開いた時にストロークエラーが発生するストロークを作成してしまう

- [対称定規] 楕円定規と併用すると正しく描画できない

- [対称定規] ブリスルや散布の方向が対称になっていない

- [矩形選択ツール・投げ縄ツール] Alt + Shift併用時の重複部分の切り出しが正しく動作しない


 ※ 13:30頃に公開後、13:40頃に更新履歴の記載漏れを追記しました。


--------------------------------------------------------------------------------------------------------------------------------------------
2019-07-28版

 ※ 注意！ : この進捗報告版以降で作成された編集作業の復元データはこれより過去の進捗報告版では復元できません。

[新機能]

- 対称定規
  ・レイヤーパネルのパース定規のメニューから作成できます。

  ・線対称および点対称の描画が可能です。点対称の分割数の上限は20です。

  ・ペン入れレイヤーにも使用できますが直接描画したストローク以外は実体のない写像になります。
    [レイヤー]メニューの[対称写像を実図形に変換]で写像を通常のストロークに変換できます。

  ・対称定規に関する情報が保存されたSAI2形式ファイルは過去の進捗報告版では正しく読み込めませんのでご注意ください。


[バグ修正]

- [散布ツール] スクラッチパッドに描画できない

- [散布ツール] 透明色を選択してもマウスカーソルに消しゴムアイコンが付かない

- [ブラシ系ツール] レイヤーフォルダに指定した不透明度保護が下位階層のレイヤーへのブラシ描画に適用されない

- [２値ペン] 設定の[ブラシ円を描画字の実サイズで表示する]がONの場合に[描画方式]が[簡易(筆圧なし)]でもブラシ円に筆圧が反映される

- [修正液ツール] 特定条件のストロークを消去しようとするとフリーズする

- [ペン入れレイヤー] 用紙質感の影響が以前のバージョンと大きく異なる

- [図形系レイヤー] 制御点操作時の検出範囲がVer.1よりかなり広い
  (Ver.1と同程度になるように直したつもりでいましたが直っていませんでした)

- [設定ダイアログ] 復元データ等の格納先として不正なパスを指定するとSAIが起動しなくなる


[変更]

- [レイヤー単独表示] カレントレイヤーへの単独表示対象の追従を元の単独表示対象の兄弟レイヤーのみに限定するよう変更

- [ブラシ系ツール] にじみ形状を指定した小径ブラシ(0～6px程度)の線質を調整

- [ブラシ系ツール] ブラシ形状のパターン散布の[角度]と[角度ぶれ]を復活

- [散布ツール] [ガウス分布]指定時にパターンの描画位置がカーソルから離れるほどパターンサイズが小さくなるよう変更

- [散布形状・散布ツール] [角度制御]が[ペンの方向]の場合に[角度]にビューの反転状態を反映するよう変更

- [修正液ツール] 複数のペン入れレイヤーを同時に消去する機能を追加

- [投げ縄ツール] クリック時は[多角形]、ドラッグ時は[手描き]となる選択モードを追加

- [矩形選択ツール・投げ縄ツール] 既存の選択領域との共通部分を選択する操作を追加 (Alt + Shift)

- [パース定規] 消失点検出の設定をパース定規毎に保持するよう変更

- [パースグリッド] 消失点検出とスナップの設定をパースグリッド毎に保持するよう変更

- [キャンバス解像度変更] [幅]と[高さ]の単位が % か pixels の場合も[印刷解像度]の変更が縦横ピクセル数に反映されるよう変更

- [ペンタブレット制御] ペン情報の取得が正常動作していないタブレットドライバでも可能な限りエラーを出さずに動作するよう修正


その他細かい調整とバグ修正


--------------------------------------------------------------------------------------------------------------------------------------------
2019-05-21版

[バグ修正]

- [散布ツール] パターンが他のツールのブラシ形状に登録されている形状数までしか認識されない


[変更]

- [ペンタブレット制御] 制御モードがVer.1互換方式の時のみペンのボタンのマッピング情報を取得するよう変更
  (ウィンドウをアクティブ化する度にWinTabエラーが発生する問題への対策です。エラーの原因はおそらくWacomのドライバのバグです)


--------------------------------------------------------------------------------------------------------------------------------------------
2019-05-19版

[バグ修正]

- [ブラシ系ツール] ブラシ形状のパターン散布で[高品質サンプリング]が適用されない

- [ブラシ系ツール] ブラシ形状のパターン散布で[高品質サンプリング]がOFFの場合に小径ブラシでアクセス違反が発生することがある

- [ブラシ系ツール] 散布形状の縮小品質指定のチェックボックスの名称が[高品質縮小]になっていない

- [マーカー] ブラシ形状が適用されない

- [散布ツール] [角度制御]のドロップダウンリストの選択状態が正しくない

- [UI] Undo/Redoで図形系レイヤーが削除されるとアクセス違反が発生することがある
  (2017-11-22版でのウィンドウのブラックアウト対策で見落としがありました)


--------------------------------------------------------------------------------------------------------------------------------------------
2019-05-18版

 ※ 注意！ : この進捗報告版以降で作成された編集作業の復元データはこれより過去の進捗報告版では復元できません。

[新機能]

- 効果ペン
  １ストローク毎にレイヤー合成を行うようなブラシツールです。レイヤー合成モードと同一のものを描画モードとして指定できます。

- 散布ツール
  散布に特化したブラシツールです。レイヤー合成モードと同一のものを描画モードとして指定できます。
  多色パターンや複数パターンへの対応は今後ブラシ形状やテクスチャの管理機能と合わせて行います。
  なお、散布ツールの実装に伴いブラシ形状としてのパターン散布は大幅に簡略化しました。


[バグ修正]

- [キャンバス] レイヤー合成処理で極稀にアクセス違反が発生する場合がある

- [編集作業の復元] 自動適用した「やり直し」に選択領域の操作が無いと常に選択領域が有効な状態で復元される

- [ブラシプレビュー] UIの倍率が200%の時にアクセス違反が発生する場合がある

- [レイヤーマスク] 陰影・発光・明暗・焼き込み・覆い焼き・焼き/覆いでマスクの合成結果がPhotoshopと若干違う

- [レイヤーの選択＆移動] レイヤーマスクを無効にした状態(マスクのサムネールの左横上段のマスをOFF)がレイヤーの選択に反映されない

- [定規類・画像変形] ガイド全体の移動が整数単位で行われない

- [ウィンドウ制御] スクロールバーとドロップダウンリストがタッチパネルで操作できない


[変更]

- [ブラシ系ツール] 論理線幅が1px以下の場合の描線の緻密さを向上

- [ブラシ系ツール] ブラシ形状のにじみをVer.1風に描画する設定を追加

- [ブラシ系ツール] ブラシ形状のにじみとブラシテクスチャを反転する設定を追加

- [ブラシ系ツール] [輪郭の硬さ]の名称を[シャープ]に変更

- [マーカー] 描画処理を全面的に見直し

- [レイヤーリスト] 複数選択時にカレントレイヤーの選択を解除できるように変更
  (カレントレイヤーの選択を解除すると選択されている別のレイヤーがカレントレイヤーになります)

- [レイヤー] レイヤー合成モードを整理
  (焼き込みリニア・覆い焼きリニア・リニアライト・焼き込みカラー・覆い焼きカラー・ビビッドライトを初期状態では
  表示しないようにしました。
  また、ハードミックスと差の絶対値をPhotoshopでいう[透明シェイプレイヤー]のOFFに相当する演算に変更しました。
  [設定]の[動作詳細]の[レイヤー]の項で非表示・変更されたモードを復活させることができます(モード名に"[TS]"と付きます))

- [レイヤー] レイヤーの単独表示がカレントレイヤーに追従するよう変更

- [設定ダイアログ] ペンタブレットの最小筆圧の設定を全てのモードに適用するよう変更
  ([Ver.1と同じ方式でWinTab APIを使用する]以外ではブラシを描画する最小筆圧となります)

- [設定ダイアログ] 下記の設定項目を追加
  ・SAIのプロセスの実行優先順位の指定
  ・復元データとサムネールキャッシュの格納先フォルダの指定
  ・レイヤー合成モードの名称をPhotoshopに合わせるかどうかの設定
  ・ビューに関する設定を数点 (ビューの表示倍率をウィンドウに合わせるか等)

- [ペンタブレット制御] WinTabモード時にはペンによるWM_POINTERメッセージを処理しないように変更
  (WACOMのドライバのバグと思われる動作によりWinTabとWM_POINTERでのペン入力が衝突する事例が報告されたためです。
  この変更により例えばMicrosoft SurfaceでSurfaceペンとペンタブレットを併用するようなことができなくなりました)

- [ペンタブレット制御] ペン先の押下通知が多重に発生する不具合を持つデバイスでメニュー等を正常操作できるよう対処
  (XP-PEN Artist 15.6 Proでペン先の押下通知が多重に発生する事例が報告されたためです)


その他細かい調整とバグ修正


--------------------------------------------------------------------------------------------------------------------------------------------
2019-01-29版

[バグ修正]

- [ファイルビューア] 時折アクセス違反が発生する
  ・カレントフォルダを含む階層を閉じた状態でリロードを行うと解放してはいけないメモリを解放してしまいアクセス違反
  ・フォルダのリネームを行うとフォルダツリーの情報に不整合を起こしてアクセス違反
  ・ファイルビューアを開いただけで内部情報の破壊を起こしてアクセス違反
  など。

- [PSD形式] Unicode αチャンネル名が終端文字で終わっていない
  (Unicode文字列の終端文字がαチャンネル名では必要だがレイヤー名では不要といった具合に一貫していないように見える)


--------------------------------------------------------------------------------------------------------------------------------------------
2018-12-23版

[バグ修正]

- [パターン散布] 一部のパラメータが正常に機能しない
  (散布ツールのUIを実装しているところだったのですが、実験的に変更していた部分を元に戻すのを忘れていましたサーセン)


--------------------------------------------------------------------------------------------------------------------------------------------
2018-12-17版

[バグ修正]

- [筆系ツール] ブリスルが殆どの場合に透明色で描画したようになる


--------------------------------------------------------------------------------------------------------------------------------------------
2018-12-16版

[バグ修正]

- [ファイルビューア] システム登録済み拡張子が非表示の場合にファイル名を変更すると拡張子が二重に付与される

- [SAI2/PSD形式] レイヤー数の上限が8190枚ではなく8189枚になっている

- [キャンバス] レイヤー数が多いとキャンバスを閉じた時にアクセス違反が発生する場合がある

- [作業の復元] 復元機能が有効な状態でレイヤーマスクのフローターを含んだSAI2ファイルを開くとアクセス違反が発生する

- [作業の復元] レイヤーマスクのフローターを含むデータを復元するとアクセス違反が発生する

- [レイヤーリスト] 移動グループの指定がマウスボタンを離すまで表示に反映されない

- [キャンバス解像度変更] ピクセルの再計算方法が[最近傍点]の場合にキャンバスからはみ出した部分にゴミが書き込まれる

- [選択領域] 選択領域が存在する際に画面外を指すタブレット座標が送られてくるとアクセス違反が発生する

- [ブラシプレビュー] Ctrl+Alt+ドラッグでブラシサイズを変更してもプレビューが更新されない

- [筆系ツール] 筆圧を弱めた場合の描画色の絡め方が間違っている

- [筆系ツール] 透明色での描画の際の筆圧の絡め方が間違っている

- [ガウスぼかし] やや強めにぼかすと微弱なゴーストのようなものが現れる


[変更]

- [筆系ツール] 混色の強さを調整

- [ファイルビューア] ビューアを開いた際に表示するフォルダ(初期フォルダ)についてルールを変更

   ※ [キャンバスを開く]を[開く]、[キャンバスを保存]と[キャンバスを別名で保存]を[保存]、
      [指定したファイル形式で出力]を[出力]と略します

   旧ルール：
   ・[開く][保存][出力]で初期フォルダのパスの記憶を共有する

   ・[開く][保存]では現在のキャンバスの保存先が有効ならそこを、無効なら最後に表示したフォルダを初期フォルダとして開く
     [出力]では常に最後に表示したフォルダを初期フォルダとして開く

   新ルール：
   ・[開く][保存]とは別に[出力]の初期フォルダのパスを記憶する

   ・[開く][保存][出力]で現在のキャンバスの保存先が有効ならそこを、無効なら最後に"選択した"フォルダを初期フォルダとして開く

   ・[開く]および[出力]で常に最後に選択したフォルダを初期フォルダとして開くかどうかの設定を追加 ([ヘルプ]→[設定]→[動作詳細])

- [レイヤー] 合成モードの[陰影＆発光]をVer.1で使用していた[明暗]という名称に変更


その他細かい調整とバグ修正


--------------------------------------------------------------------------------------------------------------------------------------------
2018-10-28版

[バグ修正]

- [キャンバス解像度変更] 必ずアクセス違反が発生する

- [ブラシプレビュー] 可視状態の設定が正しく保存されない


--------------------------------------------------------------------------------------------------------------------------------------------
2018-10-27版

[バグ修正]

- [画像変形] キャンバスの幅または高さが「２のべき乗 - 1」で[ピクセルの再計算方法]が[バイリニア]の場合に稀にアクセス違反が発生する

- [ペン入れレイヤー] 自由変形か制御点の削除を行うとパラメータ異常と判定される状態になる場合がある (ファイル読み込み時に検出される)

- [水彩筆] 水分量を 0 にして透明色を軽い筆圧で描画すると色が化ける

- [パターン散布] マーカーだと正しい濃度で描画できない

- [筆圧ツール] 曲線節に筆圧制御点を追加してそのまま左右ドラッグしても筆圧を正しく増減できない

- [ブラシ操作パネル] ツール操作パネルを分離している場合にブラシ形状を変更してもパラメータ部のレイアウトが直ちに変更されない

- [ウィンドウ操作] ウィンドウの上下辺をダブルクリックして縦方向を最大化するWindows機能が使用できない

- [スポイト] スポイトで色を取得してもグラデーションやテキストに反映されない


[変更]

- [ブラシ操作パネル] ブラシサイズ一覧の項目を数値のみで表示する設定を[ウィンドウ]メニューに追加

- [ブラシ操作パネル] ブラシサイズ一覧を上段に表示する設定を[ウィンドウ]メニューに追加

- [レイヤーリスト等] ドラッグ検出距離を1.5倍に拡大
  (以前は「半径16px×UI部品倍率」でしたが今回から「半径24px×UI部品倍率」となります。なおVer.1は16px固定でした)

- [スクラッチパッド] 通常レイヤー用のブラシ系ツール以外でも色を拾えるように変更

- [グラデーションツール] ディザリングを改良

- [直線系定規] Ctrl+定規外側ドラッグで回転できるように変更

- [パース定規] 初期配置を変更


その他細かい調整とバグ修正


--------------------------------------------------------------------------------------------------------------------------------------------
2018-09-20版

[バグ修正]

- [システムファイルダイアログ] システムファイルダイアログを使用するとアクセス違反が発生する

- [レイヤーリスト] リスト外へのドラッグ操作を行うと一度ボタンを離してどこかをクリックするまで操作できなくなる

- [パターン散布] [サイズのぶれ]を大きくするとアクセス違反が発生する

- [パターン散布] [サイズのぶれ]の影響が拡大方向にも作用する
  ([最小サイズ]～[ブラシサイズ]で変化するようにしていたつもりでしたがポカミスをしていました)

- [パターン散布] [散布]の最低値が 0% でなく 1% になっている

- [ブラシ操作パネル] ツール操作パネルを分離している場合に開閉および表示・非表示指定できる項目を変更しても直ちに適用されない

- [ブラシ系ツール] Ctrl+Alt+ドラッグでの相対サイズ変更で表示倍率が100%以外だと中心位置がずれる


[変更]

- [ブラシプレビュー] 背景モードに黒色を追加
  (プレビューをクリックする度に 透明→２色(下半分)→黒系２色(全面) と切り替わります)

- [パターン散布] 粒子系のパターンに有用なパラメータを追加


--------------------------------------------------------------------------------------------------------------------------------------------
2018-09-17版

[新機能]

- Per-Monitor DPIに対応

- ブラシ形状としてパターン散布 (暫定実装)
  現状ではにじみ等と同様にグレースケールのビットマップのみ対応で、SAIv2フォルダ内の"scatter"フォルダが格納場所です。
  まだ下記のような検討事項がありますので追々片付けていく予定です。
  ・SAIv2単独でパターンを作成して登録するインターフェイスを用意する必要がある
  ・単一パターンだけでなく複数パターンも使用できた方が良い？
  ・一度に散布する数や色相のジッタなどのパラメータも必要？
  ・カラーのパターンも使用できた方が良い？
  ・レイヤー合成モードと同等の効果で描画できた方がよい？
  ・いっそ散布専用のツールを用意するか？

- ブラシプレビュー
  ([ウィンドウ]メニューの[操作パネルの表示]で表示・非表示を選択できます)


[バグ修正]

- [画像変形] 画像変形中に選択領域の可視状態を変更してから変形操作を継続するとアクセス違反が発生する

- [グラデーションツール] 定規が表示されている場合にグラデーションツールを使用するとアクセス違反が発生する

- [ブラシ系ツール] にじみ形状の濃度特性をVer.1に合わし切れていなかったのを修正

- [ペン入れレイヤー] [選択領域と重なるストロークを選択]でベジェ曲線のハンドルもストロークとして検出されてしまう

- [ビュー] ショートカットキーでビューを切り替えるとブラシ円が表示されなくなる


[変更]

- [ブラシ系ツール] [Ver1筆圧特性]がONの場合の筆圧に対する濃度特性を調整


その他細かい調整とバグ修正


--------------------------------------------------------------------------------------------------------------------------------------------
2018-06-14b版

[バグ修正]

- [ブラシ系ツール] ブラシでの描画時にプログラムがフリーズすることがある


--------------------------------------------------------------------------------------------------------------------------------------------
2018-05-26版

[バグ修正]

- [キャンバスの解像度変更・サイズ変更] キャンバスサイズを拡大した後に別のキャンバスを閉じるとその後の自動選択等で内部データが破壊される
  (キャンバスを閉じたタイミングで予約メモリの解放が行われるのですが、キャンバスサイズを拡大した後に解放処理が実行されると
  使用中のメモリまで解放してしまい、その後に自動選択・バケツ・選択領域の膨張収縮・輪郭線の描画を行うと解放してしまったメモリを
  使用して内部データの破壊が起き、その後の描画処理で常にアクセス違反が発生するようになるといった症状でした)

- [選択領域] [すべて選択]で既存の選択領域も残ってしまう

- [ビュー] 次の優先順位のビューがフローティングビューの場合に通常ビューを閉じるとその後ろの通常ビューの配置が壊れる


[変更]

- [マルチコア処理] 各スレッドの優先順位を調整

- [ブリスル] できるだけ品質を落とさず速度が出るよう再調整

- [ブリスル] 折り返し処理を改良

- [筆系ツール] 描画色が透明である場合に混合率に[水分量]ではなく[混色]を適用するよう変更
  (Ver.1 では[混色]が適用されていましたので動作を合わせました)

- [設定ダイアログ] 分離したパネルを表示したままにする設定を追加


--------------------------------------------------------------------------------------------------------------------------------------------
2018-05-07版

[バグ修正]

- [輪郭線の描画] 別のキャンバスに適用するとアクセス違反が発生する


--------------------------------------------------------------------------------------------------------------------------------------------
2018-05-06版

[バグ修正]

- [メモリ予約量制御] 描画操作を行った後に１つのCPUの使用率が100%になったままになる場合がある

- [レイヤーマスク] 切り取りって移動しようとするとエラーになる


[変更]

- [ドロップダウンリスト] キャンセルの検出方法をマウスキャプチャを使用しないように変更


--------------------------------------------------------------------------------------------------------------------------------------------
2018-05-02版

[バグ修正]

- [メモリ管理(64bit版のみ)] Windows 10 1803 で起動直後からメモリを大量消費した状態になる
  (Windows 10 1803 でシステムが最初から大量のアドレス空間を予約していることが原因でした)

- [ウィンドウ制御] Windows 10でマウス相当の操作だとスクロールバーをクリックしてもウィンドウが有効化されない
  (マウス相当の操作だと WM_NCHITTEST で HTxSCROLL を返しても WS_xSCROLL が付いていないと WM_MOUSEACTIVATE が発生しないことが原因でした)

- [ビュー] Windows 10でマウス相当の操作だと描画領域をクリックして活性化すると次のマウスボタン押下が無視される
  (マウス相当の操作のみ MA_ACTIVATEANDEAT で WM_POINTERDOWN が抑制されるため自前の抑制処理と二重になっていたことが原因でした)

- [フローティングビュー] 常時IMEを有効にできる

- [自動選択・バケツツール] [領域検出モード]の[色差が範囲内の部分]で描線の上にまで塗り潰しが進入する

- [輪郭線の描画] レイヤーマスクに適用しても描画されない

- [UI] レイヤー消去等が可能な状態でもボタンやメニューが無効化される

- [システムIDダイアログ] IMEで文字を入力すると内容を変更できる


[変更]

- [PSDファイル] レイヤーフォルダに画像データが存在していてもエラーにしないよう修正


--------------------------------------------------------------------------------------------------------------------------------------------
2018-04-30版

[バグ修正]

- [規定サイズ編集] 規定サイズの一覧にスクロールバーが表示されていない

- [ビュー] ビュー選択バーのコンテキストメニューの機能がアクティブなビューにしか適用されない

- [水彩筆] にじみ形状を適用するとアクセス違反が発生する
  (2018-04-29版のマーカーの修正でエンバグさせてしまっていました)

- [スポイト] キャンバス背景が透明の場合に統合画像に対するスポイトで正しい色を拾えない


--------------------------------------------------------------------------------------------------------------------------------------------
2018-04-29版

[バグ修正]

- [ペンタブレット制御] Windows 10(8も?)でマウス(WinTabが生成するマウスイベントを含む)だと非クライアント領域を正しく操作できない
  (マウスとタッチパッドでの操作で WM_NCPOINTERxxxx の wParam に正しいヒットコードが設定されないことが原因でした。
  Microsoftのドキュメントに書かれていない動作であるように見えます。)

- [マーカー] にじみ形状を設定すると描画できない


--------------------------------------------------------------------------------------------------------------------------------------------
2018-04-28版

[バグ修正]

- [キャンバス保存] ファイル名に":"(コロン)が含まれているとNTFSの「代替ストリーム」に保存される (2h)

- [キャンバスの解像度変更] [縦横ピクセル数を固定]して[幅]か[高さ]を変更すると[印刷解像度]が正しく計算されない (1h)

- [ビュー] モニタの解像度変更を行うと表示が乱れたりアクセス違反が発生する場合がある (5h)

- [ビュー] フローティングビューの活性化状態が正しく制御されない (4h)

- [文字レイヤー] Ctrl+Shift+クリックやUndo/Redoでカレントレイヤーが変更されるとキー入力が効かなくなる (3h)

- [定規系レイヤー] キャンバスサイズの変更をUndo/Redoするとすべての定規系レイヤーが表示される (3h)

- [レイヤーマスク] レイヤーマスクが所属するレイヤーを変更した際にサムネールが更新されない (1h)

- [バケツツール] 領域検出元に別レイヤーを指定した塗り潰しで[塗り潰し済みの部分を無視]がOFFでも描画色と同色の部分が無視される (3h)

- [レイヤー選択＆移動] レイヤーマスクを持つレイヤーフォルダで不可視になっている部分が無視されない (1h)


[変更]

- [新規キャンバス] [規定サイズ]の編集機能を追加 (30h)

- [ファイル名入力] ファイル名への使用禁止文字の入力をブロックするよう変更 (2h)

- [筆] 初期設定の[混色]を50、[水分量]の筆圧適用をOFF、[Ver1筆圧特性]をONに変更 (1h)

- [水彩筆] 描画品質を改良 (1000h)

- [マーカー] 透明色での描画をVer.1に近くなるよう調整 (4h)

- [マーカー] 初期設定の[混色]を50、[色延び]を80に変更 (1h)

- [ペン入れツール] イリヌキのハネを除去する範囲を指定する項目を追加 (3h)

- [自動選択・バケツツール] [領域検出モード]の[透明部分]での領域の判定処理を調整 (10h)

- [ペンタブレット制御] Windows 8以降での非WinTab環境でのペンによる操作感を改善 (300h)
  (実装上の事情によりマイクロソフトのWinTabドライバは無視するように変更しました。
  また、ビュー上でのタッチ操作はジェスチャを実装するまでひとまず無効にしました。)

- [メモリ管理] メモリの予約量の調整処理を改良 (15h)


その他細かい調整とバグ修正

# 書き出してみると４ヶ月もかけてロクに仕事をしていないような印象になったので大まかな作業時間を記載してみましたｗ


--------------------------------------------------------------------------------------------------------------------------------------------
2017-12-27版

[バグ修正]

- [図形系レイヤー] 筆圧制御点とベジェ曲線のハンドルが表示倍率に比例するサイズで表示される

- [レイヤー複製] メニューから複製を行った場合に複製元と複製したレイヤーが複数選択状態になる

- [特殊効果] [特殊効果の発色]が[Ver.1風]である場合にアクセス違反が発生する場合がある

- [作業の復元] 復元ポイントで選択領域が不可視になっているとアクセス違反が発生する


その他細かい調整とバグ修正


--------------------------------------------------------------------------------------------------------------------------------------------
2017-12-21版

[バグ修正]

- [選択領域] 選択領域を不可視にしてから解除すると選択ペンで不可視レイヤーの警告が出て描画できなくなる

- [ツールシフト] ツールシフトと同時に入力したキーが無視される場合がある

- [レイヤー複製] 子階層に独立した移動グループを持つレイヤーフォルダをメニューから複製すると複製した子レイヤーも同じ移動グループになる

- [キャンバス] キャンバスが無効になっている状態でショートカットキーで[キャンバスを閉じる]を行うとアクセス違反が発生する

- [文字レイヤー] Undo/Redoで編集位置が復元されない

- [スポイト] 透明背景のキャンバスで描画部分に近い位置で統合画像のスポイトを行うと透明ではなく白が拾われる

- [スポイト・レイヤー選択＆移動] レイヤーマスクで不可視になっている部分が無視されない


[変更]

- [ブリスル] 折り返しをやりやすいよう判定処理を調整

- [すべて選択] 図形系レイヤーでは全ての制御点の選択、文字レイヤーでは全テキストの選択になるよう変更

- [自動選択・バケツツール] すでに描画色と同色の部分または選択済みの部分を境界として検出しないようにするチェックボックスを追加
  (2016-07-27版～2017-12-01版までは常に同色部分を境界として検出していましたが、漏れ出し防止を使用する際に適正幅を探りつつ
  塗り潰す場合の弊害になるため本バージョンから同色部分を無視する設定を追加しました)


その他細かい調整とバグ修正


--------------------------------------------------------------------------------------------------------------------------------------------
2017-12-01版

[バグ修正]

- [作業復元] 復元後にレイヤーの情報がレイヤーリストに正しく表示されない場合がある

- [レイヤー] レイヤー名の文字数が 0 のレイヤーを含む.sai2形式を読み込むとアクセス違反が発生する

- [ツール全般] ブラシ系以外のツールに常に手ぶれ補正10が適用される

- [ブラシ系ツール] ブラシサイズが64以下になった場合に水彩境界が正しく更新されない

- [投げ縄ツール] 手ぶれ補正有効時に曲線補間が適用されない


[変更]

- [ブラシ系ツール] 実際のブラシサイズのブラシ円の表示で描画中でない場合は最大サイズのブラシ円も表示するよう変更


--------------------------------------------------------------------------------------------------------------------------------------------
2017-11-28版

[バグ修正]

- [レイヤーフォルダ] 子階層に不可視のレイヤーがあると選択領域で切り取り・移動・変形ができない

- [レイヤーフォルダ] ピクセルの不透明度保護が子階層のレイヤーに適用されない


[変更]

- [レイヤー加工] 不可視のレイヤーの加工操作のルールと設定ダイアログの関連する項目を修正
　(これらの修正は切り取り、移動、変形、ラスタライズ、色調補正に適用されます)


その他細かい調整とバグ修正


--------------------------------------------------------------------------------------------------------------------------------------------
2017-11-27版

[バグ修正]

- [レイヤー結合] レイヤーフォルダとその子を選択した状態で結合操作を行うとアクセス違反が発生する

- [レイヤー結合] クリッピンググループの親になっている図形系レイヤーを他の図形系レイヤーに結合するとラスタライズして結合される

- [同心円定規] 回転や反転させるとガイドが正しく表示されない

- [同心円定規] 定規を横切るようにストロークすると定規から外れて直線が描画される

- [パースグリッド] 消失点が存在しない場合にスナップなしの際のガイド線にグリッドの回転が反映されない


[変更]

- [レイヤーフォルダ] フォルダを選択した状態での子階層レイヤーの描画の禁止を解除

- [画像変形] ペン入れレイヤーの線幅を維持する設定のチェックボックスを追加

- [設定ダイアログ] [動作詳細]にいくつかの設定を追加

- [設定ファイル] 設定ファイル破損時の回復処理を改良


--------------------------------------------------------------------------------------------------------------------------------------------
2017-11-24版

[新機能]

- 平行線定規、同心円定規、集中線定規


[バグ修正]

- [ブラシ系ツール] にじみを指定しても適用されない

- [画像変形] フローターを反転・90度回転しようとすると不可視レイヤーに対する警告が出て実行できない


--------------------------------------------------------------------------------------------------------------------------------------------
2017-11-23c版

[バグ修正]

- [ヒストリ] Undo/Redoでアクセス違反が発生する


--------------------------------------------------------------------------------------------------------------------------------------------
2017-11-23版

[バグ修正]

- [ペン入れレイヤー] ストロークが正しい線幅で表示されない

- [パースグリッド] 分割数を 0 にするとメモリを大量消費してフリーズする


--------------------------------------------------------------------------------------------------------------------------------------------
2017-11-22版

[新機能]

- 指先ツール

　・初めてSAIv2を起動した場合以外は自動的に作成されませんのでカスタムツールトレイの空きスロットを右クリックして
　　手動で作成してください。

　・通常は速度最優先の簡略化された処理が行われますが、ブラシテクスチャを適用するとPhotoshopに似た品質優先の
　　処理方法に切り替わります(簡略化した処理がブラシテクスチャと極端に相性が悪かったためそのようにしました)。
　　ブリスルとブラシテクスチャを併用すると大幅に速度が低下しますが不具合でありません。

　・ブラシテクスチャを指定して[強さ]を 0 にするとPhotoshopに似た結果が得られます。


[バグ修正]

- [定規系レイヤー] レイヤー関連の操作パネルを分離しているとクイックバーの定規に関するボタン等の表示が正しく制御されない

- [画像変形] 90度回転を行ってから変形ガイドを操作するとガイドがさらに90度回転して裏返る

- [ガウスぼかし] ぼかし幅を変更またはプレビューをONにしたあと直ちにプレビューをOFFにするとアクセス違反が発生する

- [PSDファイル] Shift-JISに変換すると255バイトを超えるレイヤー名を持つレイヤーがあると正しい構造で保存されない


[変更]

- [UI] ファイル入出力や画像変形など時間がかかる処理を行っている間もウィンドウメッセージを処理するよう変更
  (ウィンドウのブラックアウト対策です。但し一部のケースではまだブラックアウトする可能性があります)

- [ブラシ系ツール] 筆圧反映チェックボックスを廃止して関連するスライダの左に同機能のスイッチを追加

- [ブラシ系ツール] 大径の平坦ブラシの波紋状の筆跡を低減する機能をON/OFFする設定[波紋低減]を追加
  (前版までは常にONになっていました)

- [ブラシ系ツール] 平坦ブラシ(ボケ足選択の右端、波紋低減=ON)を 15% ほど高速化

- [ブラシ系ツール] 平坦ブラシ以外のボケ足をVer.1と同等の幅になるよう調整

- [ブラシ系ツール] ブリスルの挙動を全面刷新

- [筆系ツール] 水分量に対して筆圧を適用するかどうかのスイッチを追加
  (前版までは常に筆圧が適用されていました。Ver.1では常に筆圧が適用されていなかったのを完全に失念していましたサーセン)

- [マーカー] 濃度増幅を100にすると１クリックで指定した描画濃度で描画されるよう変更

- [投げ縄ツール] [選択方法]が[手描き]の場合に手ぶれ補正が適用されるよう変更

- [設定ダイアログ] 分類を整理


その他細かい調整とバグ修正


--------------------------------------------------------------------------------------------------------------------------------------------
2017-08-20版

[バグ修正]

- [Ver.1方式WinTab制御] マルチディスプレイ環境でマウスカーソルの位置がズレる


[変更]

- [操作パネル] ブラシ系ツールの操作パネルのレイアウトを調整


その他細かい調整


--------------------------------------------------------------------------------------------------------------------------------------------
2017-08-16版

[バグ修正]

- [ビュー／スクラッチパッド] 何やら色々と誤動作する


--------------------------------------------------------------------------------------------------------------------------------------------
2017-08-15b版

[バグ修正]

- [初期化] スクラッチパッドのデータがあらかじめ存在していないと起動できない


--------------------------------------------------------------------------------------------------------------------------------------------
2017-08-15版

[新機能]

- スクラッチパッド
　(色々改良案を練りましたが結局Ver.1とほぼ同じものになりましたサーセン)


[バグ修正]

- [ビュー] ビュー上のコンテキストメニューの項目を選択できず、閉じることもできない

- [ビュー] ビューバーで選択するとフローティングビューの順序が変わらない

- [図形系レイヤー] 制御点の表示においてごく稀なケースでアクセス違反が発生する

- [レイヤーマスク] キャンバスの幅または高さが 11585px 以上になるとサムネールが壊れる

- [マルチコア処理] 論理CPUが32個を超える場合に大幅な処理の遅延が発生する


[変更]

- [操作パネル] レイアウトを調整


その他細かい調整


--------------------------------------------------------------------------------------------------------------------------------------------
2017-07-29版

[バグ修正]

- [ブラシ系ツール] 設定ダイアログでVer.1方式のWinTab制御の[クリックされたとみなす最小筆圧]を指定すると正常に動作しない


--------------------------------------------------------------------------------------------------------------------------------------------
2017-07-28版

[バグ修正]

- [自動選択・バケツ] 領域抽出元を統合画像にしてレイヤーマスクに使用すると正常に動作しない


[変更]

- [ブラシ系ツール] ストロークのイリヌキの品質をさらに調整


--------------------------------------------------------------------------------------------------------------------------------------------
2017-07-27版

[新機能]

- Ver.1と同様のWinTab制御方式
  (Ver.1と同様のマウスモードが使用できるようになりました)

- ナビゲータの最大サイズの変更


[バグ修正]

- [ヒストリ] 解像度変更や画像変形等の複数レイヤーが対象となる操作のUndo/Redoで閉じているレイヤーフォルダが開かれる

- [ヒストリ] ファイルを開く、編集、閉じるという操作を素早く行った場合に一部のヒストリファイルが開かれたままになる

- [キャンバスの解像度変更] 印刷解像度だけを変更すると何も起こらない

- [キャンバスの解像度変更] フローティングがある状態で解像度を変更するとアクセス違反が発生する

- [クリップボード] フローティングがある状態でコピー(Ctrl+C)を行うとアクセス違反が発生する

- [操作パネル] ツールパネルを分離している場合にツールシフトでツールパラメータの部分が正しく切り替わらない

- [操作パネル] 一部の項目の再描画が正しく行われない

- [操作パネル] [操作パネルの部品のサイズ]が100%でない場合にナビゲータかレイヤーのパネルを分離すると一部の部品のサイズがおかしくなる

- [ツール全般] 通常レイヤー以外でテールスイッチ側のツール選択が正しく動作しない

- [ツール全般] 選択ペン・選択消しと他のツールでテールスイッチ側のツール選択が独立していない (Ver.1と異なる動作)

- [修正液ツール] 特定条件の直線に[交点まで削除]を行うとフリーズする


[変更]

- [設定ダイアログ] 設定項目をカテゴリ別に表示するよう変更

- [ブラシ系ツール] 水彩筆とマーカー以外の[輪郭の硬さ]の初期値を 0 から 50 に変更

- [ブラシ系ツール] ストロークのイリヌキの品質を調整

- [ブラシ系ツール] 筆圧感度 101～200 の特性を調整

- [ブラシ系ツール] Ver.1と同じ手ぶれ補正制御を適用するオプションを追加 (設定→ツール)

- [ファイル保存] 2017-05-31版の保存処理の変更を止めて別の方法に変更
  (一部の環境のネットワークドライブで正常に保存できない問題が見付かったため)

- [PSD形式] SAI Ver.1で作成したPSDの発光・陰影の合成モードを正しく読み込めるよう変更
  (絶対確実な方法で判別できないので正しく読み込めない場合があるかも知れません)


その他細かい調整とバグ修正


--------------------------------------------------------------------------------------------------------------------------------------------
2017-06-07b版

[バグ修正]

- [レイヤー移動] 用紙質感を指定したレイヤーフォルダを移動するとアクセス違反が発生する


--------------------------------------------------------------------------------------------------------------------------------------------
2017-06-07版

[バグ修正]

- [フローティングビュー] 他のウィンドウを操作するとストロークの始点に筆圧100%での描画が行われる

- [ヒストリ] ヒストリデータファイルの作成時のエラーを正しく処理できていない

- [作業の復元] 復元ダイアログ用のサムネールの書き出しでエラーが発生すると無限ループに陥る場合がある


その他細かい調整とバグ修正


--------------------------------------------------------------------------------------------------------------------------------------------
2017-06-01版

[バグ修正]

- [修正液] [消去の延長]の[交点まで]が動作しない

- [自動選択、バケツ] アンチエイリアスを有効にしていると特定のケースでフリーズする

- [スポイト] カレントビュー以外で動作しない

- [キャンバスのリサイズ] リサイズ後のキャンバスがビューの外側に配置される場合にビューが更新されない


[変更]

- [ビュー] ウィンドウモードでビューを作成した際のキャンバスの周囲の隙間を若干広くなるよう調整


その他細かい調整とバグ修正


--------------------------------------------------------------------------------------------------------------------------------------------
2017-05-31版

[新機能]

- 強制終了等からのキャンバスの復元機能 ([ファイル]メニュー → [編集作業を復元])


[バグ修正]

- [最近使ったファイル] 最近使ったファイルのリストが蓄積され続けて最終的にプログラムが起動できなくなる

- [ビュー] キャンバスの解像度変更やサイズ変更の後にアクセス違反が発生して操作不能になる場合がある

- [ビュー] 複数ビューで作業しているときカレント以外のビューに描画結果を正しく反映できない場合がある

- [ペンタブレット制御] ペンを検知範囲から離してもマウス操作ができないままになる場合がある

- [レイヤーマスク] レイヤーマスクを適用するとブロック状に濃度が正しくない部分ができる場合がある

- [図形系レイヤー] パスの制御点をすべて削除しても見えないパスや図形のデータが残ってしまう(変形対象に含まれてしまうなどの影響がある)

- [図形系レイヤー] 「選択領域と重なるストロークを選択」に以前検出したパスが含まれてしまう

- [図形系レイヤー] 修正液ツールの[交点まで削除]の判定にベジェ曲線のハンドルの端点が含まれる

- [レイヤーリスト] フォルダの内部的な開閉状態が更新されずキー操作で見た目どおりに階層を移動できない場合がある

- [クリップボード] レイヤーマスクのクリップボードデータがプログラムの終了時に壊れたビットマップに置き換えられる

- [クリップボード] 複数レイヤーをコピーして他のプログラムに貼り付けるとレイヤーの順序が逆になる

- [ツールシフト] ドラッグ開始直後にキーを離してもドラッグ終了までキーを離していないものとして判定される

- [投げ縄ツール] 右クリックでのスポイトが使えない

- [図形ツール] 図形の作成操作でサイズ制限に達したときにガイドが常に始点から左方向にドラッグしたように配置される

- [操作パネル] モニタの解像度を変更するとリストボックスの表示が乱れる


[変更]

- [ヒストリ] Undo可能回数を100回固定から100～200回(操作状況によっては200回以上)間で変動する仕様に変更
  (復元機能が有効になっている場合のみです。復元機能が無効なら従来通り100回固定となります)

- [ファイル保存] 保存処理の一部をファイル同期プログラム等との衝突を回避できる方法に変更

- [レイヤーリスト] 項目選択の判定がVer.1よりシビアであったのを改善

- [描画色] 前景色と背景色を交換した際に透明色を解除するよう変更 (Ver.1 と同じ動作)

- [カラー２値化] Ver.1と同じ動作になるよう修正


その他細かい調整とバグ修正


--------------------------------------------------------------------------------------------------------------------------------------------
2017-01-19版

[バグ修正]

- [SAI2形式] ディザパターンのような圧縮率が極端に悪い部分を多く含む画像の保存を行うと内部データが破壊される


--------------------------------------------------------------------------------------------------------------------------------------------
2016-12-24版

[バグ修正]

- [レイヤー] レイヤーを単独表示にすることができない
  (2016-12-12版で不可視のフォルダを操作対象にできるようにしたことでエンバグさせていました)

- [キャンバス読込] 常に最上位のレイヤーがカレントレイヤーになる
  (テスト用のコードを削除するのを忘れていました)

- [図形系レイヤー] 曲線節を掴んでマクロ変形すると曲線節の手前の制御点が一緒に掴まれた状態になる
  (2016-06-19版からエンバグさせていました)

- [画像変形] 補間方法が[Lanczos 3]の場合、縮小率によってはエラーが出て変形できない

- [文字レイヤー] ユーザーパレットから色を選ぶとテキストに反映されない

- [文字レイヤー] テキストに選択範囲があると文字ツールを選択していなくても色の変更ができてしまう

- [文字ツール] ツールのパラメータが保存されない

- [バケツツール] 一旦塗り潰した後に選択領域が適用される形になっている (Ver.1では選択領域内だけで領域判定が行われる)

- [ファイルビューア] 新規作成したキャンバスを保存するとき常にデスクトップが表示される

その他細かい調整とバグ修正


--------------------------------------------------------------------------------------------------------------------------------------------
2016-12-12b版

[バグ修正]

- [ツールのショートカットキー] 初めて起動したのが2016-12-12版だった場合にショートカットキーの設定ダイアログを開くとエラーが発生する
  (このバグに当たった場合ツールのショートカットキーがめちゃくちゃになります。<マイドキュメント>\SYSTEMAX Software Development\SAI2 Demoに
  あるsettings2.ssdを一旦削除してください)


--------------------------------------------------------------------------------------------------------------------------------------------
2016-12-12版

[バグ修正]

- [描画系全般] CPU負荷がかなり高い状態で連続して描画を行ったとき画像データが破壊されてアクセス違反が発生する場合がある

- [フローター] 切り取った画像を変形・確定して直ちにブラシ描画を行うと画像データが破壊されてアクセス違反が発生する場合がある

- [フローター] 複数レイヤーからフローターを作成したとき最背面のレイヤーのみから選択領域が作成される

- [レイヤー] フローターがある状態から境界線の描画を行ったときにプレビューが動作しない

- [自動選択・バケツツール] レイヤーマスクに使用すると領域抽出元が不可視であるとエラーが出て適用できない

- [自動選択・バケツツール] [透明部分]モードの場合に透明な部分しか塗り潰せない (Ver.1は透明でない箇所も塗り潰せる)

- [マーカー] 透明色を選択していると描画濃度や混色が働かずただ消去したようになる
  (透明色でVer.1と類似した結果を得るには[濃度増幅]を100、[Ver1筆圧特性]をONにしてください)

- [色調補正フィルタ] ピクセル不透明度を保護したレイヤーへの適用結果が正しくない

- [JPEG形式] キャンバスの背景が透明の場合に保存品質プレビューでアクセス違反が発生する

- [JPEG形式] グレースケールのJPEGファイルを読み込むと色化けが発生する


[変更]

- [自動選択・バケツツール] 対象が不可視でもエラーにならないよう変更

- [サムネールクリックでの選択領域作成] 対象が不可視でもエラーにならないよう変更

- [選択領域] 非表示にしている場合に全ての操作のUndo/Redoで自動的に可視化されないよう変更

- [ブラシ系ツール] [濃度増幅]を100に設定した場合の筆圧に対する濃度変化がVer.1に近い結果になるよう調整

- [ブラシ系ツール] にじみの効果がVer.1に近い結果になるよう調整

- [消しゴム、選択ペン、選択消し] 初期設定を筆圧でサイズと濃度が変化しない設定に変更
  (Ver.1と同様の動作)

- [マーカー] 初期設定の[濃度増幅]を100、[Ver1筆圧特性]をONに変更


その他細かい調整とバグ修正


--------------------------------------------------------------------------------------------------------------------------------------------
2016-11-19版

[バグ修正]

- [ビュー選択バー] 項目を元の位置でドロップすると無限ループに入ってメモリを大量消費しながらフリーズする

- [レイヤー] レイヤーフォルダを単独表示にしたときに中のレイヤーのクリッピンググループが一時的に解除される

- [レイヤー] パース定規かパースグリッドを作成しようとするとアクセス違反が発生する

- [画像変形] 選択領域がある状態から画像変形を実行したあと直ちにUndoすると画像データが破壊されてアクセス違反が発生する場合がある
  (メモリ破壊の原因の一つでした)


--------------------------------------------------------------------------------------------------------------------------------------------
2016-11-17版

[新機能]

- ビュー選択バー項目の並び替え

- ビュー選択バー項目へのレイヤーリスト項目のドラッグによるレイヤーのコピー

- ビュー選択バー項目のコンテキストメニュー


[バグ修正]

- [分離パネル] Alt+F4で閉じることができ、後にアクセス違反が起きる場合がある

- [ビュー] 楕円定規と変形ガイドの中心の十字と筆圧制御点に表示角度や左右反転が正しく反映されない

- [レイヤーリスト] レイヤー項目を末尾以降にドラッグしたとき末尾に移動させる操作が機能していない

- [レイヤー] レイヤーの可視状態の変更で他のビューやナビゲータが更新されない

- [レイヤー] レイヤーを単独表示にしたときに一時的にクリッピンググループが解除されない

- [レイヤー] フォルダを編集禁止にしても中のレイヤーにバケツツールとグラデーションツールが使用できる

- [バケツツール] 描画色の緑と青が 0 でかつ透明色を選択していると塗り潰せなかったり縦縞のゴミが現れたりする

- [筆圧ツール] 筆圧制御点を追加したとき筆圧の数値表示が消えない

- [ガウスぼかし] 画像がキャンバス外にはみ出している状態でガウスぼかしを実行するとアクセス違反が発生する場合がある
  (メモリ破壊の原因の一つでした)


--------------------------------------------------------------------------------------------------------------------------------------------
2016-11-12版

[バグ修正]

- [分離パネル] ボタンを押しても機能が実行されない

- [スクラブズーム] 内部的な表示倍率と実際の表示倍率の不一致が起きて描画位置などがずれる

- [ペン入れレイヤー] 2016-11-11版の修正液ツールを使用した際にフリーズするバグの修正が直し切れていない

- [システムファイルダイアログ] 複数のファイルを選択して開くことができない


--------------------------------------------------------------------------------------------------------------------------------------------
2016-11-11版

[新機能]

- 操作パネルの分離


[バグ修正]

- [ビュー] スクリーンの垂直ピクセル数が32px単位の場合に全画面モード・操作パネル非表示・ビューのスクロールバー無しでビューの表示角度が
　180°<= θ < 360°になるとアクセス違反が発生する

- [ペン入れレイヤー] 複数の筆圧制御点を選択して移動させると選択されていない点と順序が入れ替わる場合がある

- [ペン入れレイヤー] 上記入れ替わりバグが発生しているストロークに修正液ツールを使用するとメモリを大量消費しながらしばらくフリーズする

- [選択領域] 選択領域の1px膨張が元の領域より少し大きい範囲で切り落とされる

- [直線定規] コンテキストメニューの[回転軸を固定]が反映されない

- [ブラシ系ツール] 直線描画モードでShiftを押すと最後にブラシを描画した点からのガイド線が表示される

- [ペン入れツール] 最後の制御点が必ず鋭角点になる

- [自動選択・バケツツール] 領域抽出元が不可視のフォルダだとアクセス違反が発生する


[変更]

- [レイヤー] 通常レイヤーの転写をVer.1と同じ動作に変更
  (結合先の不透明度が100%未満なら100%に訂正して特殊効果はそのまま維持します)

- [拡大鏡ツール] [矩形範囲を拡大(矩形ズーム)]と[左右ドラッグで拡大縮小(スクラブズーム)]の操作を追加

- [筆圧変更ツール] ビュー上で筆圧を数値表示するよう変更

- [ブラシ系ツール] ブラシサイズの変更時にビュー上でプレビューとサイズを表示するよう変更

- [スポイト] 対象が統合画像のときキャンバスの背景色が透明なら常に白背景に合成した色を拾うよう変更

- [ツール全般] ショートカットキーを文字キーではなく仮想キーコードで割り当てるよう変更


--------------------------------------------------------------------------------------------------------------------------------------------
2016-11-02版

[バグ修正]

- [レイヤー] カレントレイヤーを含むレイヤーフォルダをコピーすると暴走する

- [ブラシ系ツール] 筆圧感度が反映されない

- [ファイルビューア] 詳細表示にしたときに縦横ピクセル数がすべて 0x0 として表示される

- [ファイルビューア] SAI形式の寸法情報が記録されていない
  (サムネールを更新すると寸法情報が作成されるようになりました)


[変更]

- [ファイルビューア] 項目をポイントするとパス名や寸法情報が表示されるよう変更
  (変更というか単に作るのを忘れていました)


--------------------------------------------------------------------------------------------------------------------------------------------
2016-11-01版

[バグ修正]

- [キャンバス] 選択領域を作成した場合などにキャンバスの外周に薄い枠線ができる
  (2016-10-30版で周辺色を調整しましたが、修正に抜かりがありました)

- [キャンバスの反転／90度回転] 選択領域が含まれない

- [レイヤー] レイヤー名の序数の前に 0 を付けると８進数として処理されて 0 が消える
  (単に基数の指定が抜かってたというオチでした。あと今回から 0 付いた数値は序数とみなさないように変更しました)

- [レイヤー] レイヤー名を序数だけにすると名前が空になる

- [選択領域] 選択領域を移動／反転／90度回転した後で選択領域を不可視にしてからUndoすると選択領域の表示が壊れる

- [文字ツール] 文字入力中にコピーや貼り付けなどCtrlを併用する操作ができない
  (2016-10-30版で文字入力中にナッジを使えるようにしたところで間抜けなミスをしていました)

- [修正液ツール] 角度がついた部分の制御点が鋭角点に変換される
  (以前からあったバグですが、2016-10-30版で鋭角点検出のしきい値を変更したことにより露見するようになりました)

- [ファイルビューア] 保存時にファイルペインでフォルダをダブルクリックするとフォルダを開くのではなく確定の操作になる

- [ファイルビューア] ショートカットを指定して確定するとエラーになる

- [SAI形式] 読み込みの際にエラーが発生して中断されることがある
  (未初期化の変数にアクセスしていました。SAI形式に対応した時からあったバグですがこれまで偶然露見しなかったようです)

- [ダイアログ全般] 位置の記憶を行わないダイアログが必ずプライマリモニタの内側に表示される


[変更]

- [レイヤー] コピーしたレイヤーがカレントレイヤーの上に作成されるよう変更

- [レイヤー] 通常レイヤーを単体で結合・転写した場合に結合先の透明度や特殊効果を調整して見た目を維持するよう変更
  (図形系レイヤーはラスタライズしない限り見た目の維持ができないのでこの変更は適用されません)

- [選択領域] レイヤーの切り取り、移動、反転・90度回転などで非表示にしてある選択領域が可視化されないよう変更


--------------------------------------------------------------------------------------------------------------------------------------------
2016-10-30版

[新機能]

- ファイルビューア
  (今回はPer Monitor DPI等に対応するためサムネールの元となる内部データをかなり大きめにしてJPEG形式で保持、表示の際は動的縮小を
  行うというヘビーな仕様になってしまいVer.1と比較してサムネール表示がかなり遅くなりました。腹立たしい限りなので可能であれば
  いずれ速度の改善を行いたいと思います)


[バグ修正]

- [キャンバスサイズの変更] 延長量指定でキャンバスの縦横ピクセル数が変化しない形の数値を指定するとサイズ変更が行われない

- [フローター] 切り取った画像を画面外に持っていって変形して確定するとその後暴走する

- [レイヤー] レイヤーフォルダを選択した状態で選択領域によるパス選択を行うとフリーズする

- [レイヤー] クリッピンググループを結合したときグループの上側の項目がフォルダの子か別のグループの子だとそれらも一緒に削除される

- [レイヤー] コピーしたレイヤーまたはレイヤーフォルダに可視状態と開閉状態が引き継がれない

- [レイヤー] レイヤーフォルダ内の末尾のレイヤーフォルダを統合すると次のレイヤー項目と同じ階層レベルに挿入される

- [レイヤー] レイヤーフォルダ内の末尾の図形系レイヤーをラスタライズすると次のレイヤー項目と同じ階層レベルに挿入される

- [レイヤー] レイヤーフォルダを選択した状態でクリップボードから複数レイヤーを貼り付けると逆の順序で挿入される

- [レイヤー] ビューの反転がレイヤーのナッジに反映されない

- [レイヤー] クリッピンググループの親を選択した状態でパース系定規を作成するとグループに組み込まれて解除できなくなる

- [レイヤー] レイヤーフォルダを単独表示にしたとき可視化が直下の階層にまでしか適用されない

- [レイヤー] 選択＆移動で選択したレイヤーが閉じたフォルダの中にあった場合にフォルダが自動的に開かれない

- [レイヤー] 選択領域がある場合にレイヤーの選択＆移動ができない

- [レイヤーリスト] 一旦別のキャンバスに切り替えて戻ってくるとスクロール位置がリセットされる

- [SAI/PSD形式] 既存のファイルを開いて新規レイヤーを作成すると序数が１から始まる

- [ユーザーパレット] 128色を超えた辺りでスロットが拡張されなくなる
  (テストのために数を減らしたままになっていました。本来は8000色を超えた辺りが上限です)

- [ツールシフト] Caps、半角/全角、かな などのキーを押すとツールシフトが誤動作するようになる
  (放されたことが通知されないキーで問題が起きていました)

- [文字ツール] 文字入力中にCtrl+カーソルキーでナッジができない


[変更]

- [レイヤーリスト] 項目のデザインを若干変更

- [レイヤーリスト] ある項目を単独表示にしたときフォルダ階層における先祖と子孫すべての項目の目アイコンが赤くなるよう変更

- [レイヤーマスク] 透明色を黒として扱うよう変更 (2016-07-30版の変更のキャンセル)

- [ペン入れレイヤー] 変形の際のパースの影響をVer.1と同様の動作に変更
  (パースが 0 の場合は変形前後の各辺の長さの変化から倍率を求めます)

- [パース系定規] ガイド線の濃度が濃すぎたので薄く変更

- [パースグリッド] 回転操作を追加 (Alt + 制御点ドラッグ)

- [ビュー] スクロール可能な範囲をVer.1と同じ幅に変更する設定を設定ダイアログに追加

- [直線モード・グラデーションツール] Shift押下時に斜め45度にも吸着するよう変更

- [ブラシ系ツール] Shift+クリックで最後にブラシを描画した座標から今回クリックした座標まで直線を描画するよう変更

- [水彩筆] 初期設定がVer.1に近くなるよう変更 (濃度増幅=0→50, Ver1筆圧特性=off→on)

- [ペン入れ] ストロークの始めと終わりのハネを削除するよう変更
  (ストロークの両端から[許容誤差]の６倍の範囲内にあるハネを削除します。余計だという意見が多いようならON/OFFの設定を追加します)

- [修正液] 「ベクター化」の設定を追加
  (許容誤差の最小値を1.0pxに上げたので若干精度は落ちましたが制御点の増加は抑えられるようになりました)

- [曲線・直線ツール] 確定後にUndoするとVer.1と同様に制御点追加モードに戻るよう変更


その他細かい調整とバグ修正


--------------------------------------------------------------------------------------------------------------------------------------------
2016-07-30版

[新機能]

- レイヤーマスク操作のショートカット


[バグ修正]

- [レイヤーマスク] レイヤーリストの項目上でマスク反映と移動リンクのボタンが動作しない

- [キャンバスサイズの変更] 移動リンクがOFFになっているレイヤーマスクの位置がずれる

- [選択領域] 膨張・収縮で四角い穴が発生する

- [画像変形] 選択領域で複数レイヤーを変形したときに最下層のフローターが空だと全フローターが認識されなくなる

- [文字ツール] 文字ツールが選択されているときに「操作パネルの部品のサイズ」を変更するとアクセス違反が発生する

- [ブラシ系ツール] ブリスルの描画に極端に時間がかかる場合がある

- [バケツツール] 透明色での塗り潰しでブロック状の塗り残しができる

- [色調補正フィルタ] プレビューのON/OFFが最上位のレイヤーにしか適用されない


[変更]

- [レイヤーマスク] 透明色を黒ではなく白として扱うよう変更


--------------------------------------------------------------------------------------------------------------------------------------------
2016-07-27版

[新機能]

- ペン入れレイヤー・図形レイヤーに対する切り取り・コピー・貼り付け
  (レイヤーが複数選択されている場合は無効です)

- レイヤー保護等のショートカット

- ビューの切り替えのショートカット


[バグ修正]

- [ナビゲータ] 表示倍率と表示角度のトラックバーの操作がビューに正しく反映されない
  (2016-06-24版の修正で直し切れていませんでした)

- [ナビゲータ] ビューの回転・拡大縮小でナビゲータの表示位置ガイドが更新されない

- [レイヤー] レイヤーリストの下端の空のレイヤーフォルダを操作・編集した場合にアクセス違反が発生する

- [レイヤーマスク] ブラシ描画での描画色の扱いが正しくない
  (反転モードでの動作をPhotoshopと同じにしたつもりでしたがエンバグさせていました)

- [レイヤー結合] クリッピンググループに不可視のレイヤーが１つだけ存在する状態で結合を行うとアクセス違反が発生する場合がある

- [レイヤー結合] クリッピンググループを統合した際に不可視のレイヤーが残ってしまう

- [ペン入れレイヤー] Alt+矩形選択でストローク全体の選択を解除しても内部的には選択されたままになるケースがある

- [ペン入れレイヤー] レイヤーおよびキャンバスの反転・90度回転の後に編集ができなくなる

- [ガウスぼかし] ピクセル不透明度が保護されている場合にピクセル不透明度が保護される形でぼかしが適用されない

- [投げ縄ツール] 多角形選択で確定時にAltキーを押しておかないと領域の削除にならない

- [投げ縄ツール・グラデーションツール] ツールシフトしてからドラッグを開始すると元のツールに戻ってしまう

- [バケツツール] すでに描画色になっている部分が塗り潰しから除外されない
  (Ver.1では除外されます)

- [筆圧ツール] 濃度筆圧の変更ができない


[変更]

- [レイヤー結合] 複数レイヤー選択時のレイヤー結合でクリッピンググループが絡む場合の制限(*1)を廃止
  (*1 連続した項目しか結合できない、グループ内外の項目を結合できないなど)

- [ブラシ系ツール] ブラシサイズ円の合成をVer.1と同等の演算に変更


その他細かい調整とバグ修正


--------------------------------------------------------------------------------------------------------------------------------------------
2016-06-24版

[新機能]

- レイヤーフォルダからの選択領域の作成・追加・除去
  (レイヤーリストのフォルダの開閉ボタンを修飾キー＋クリックすると実行できます。レイヤーサムネールに対する操作と同じです)

- Ctrl+カーソルキーでの変形中の画像の移動


[バグ修正]

- [中間色バー] 中間色バーから色を拾った後でカラーサークルから拾った色を登録すると白が登録される

- [ナビゲータ] 表示倍率と表示角度のトラックバーの操作がビューに正しく反映されない

- [キャンバス] キャンバスの縦×横のピクセル数が256Mピクセルを超えた場合にレイヤーサムネールにゴミが入る

- [キャンバス] キャンバスの左右反転・90度回転でレイヤーマスクが処理されない

- [レイヤー] レイヤーリストの項目を他のキャンバスのビューへドラッグ＆ドロップすることができない

- [レイヤー] レイヤーフォルダを選択した状態で中のレイヤーに色調補正系フィルタなどが適用できない
  (描画系フィルタ(現状ではガウスぼかしのみ)については複数レイヤーへの同時適用を実装する予定はありません)

- [レイヤー] 通常レイヤー以外にもレイヤーマスクの適用ができてしまいアクセス違反が発生する

- [図形レイヤー] 変形ができない

- [ブラシ系ツール] Ctrl+Altで表示されるポップアップパネルのスライダが操作できない

- [ブラシ系ツール] ドットカーソルを指定しても消しゴム・２値ペン・ペン・修正液で矢印カーソルのままになる


[変更]

- [レイヤー] レイヤーフォルダを選択した状態で中のレイヤー全てを選択範囲で切り取り・コピー・移動できるよう変更

- [レイヤー] 選択範囲がある状態でもカーソル位置のレイヤーの選択＆切り取り＆移動(Ctrl+Shift+ドラッグ)ができるよう変更

- [レイヤー] 修飾キーなしでレイヤーサムネールをクリックした場合にVer.1と同様にレイヤー項目が選択されるよう変更

- [操作パネル] レイヤーやツールの項目をダブルクリックしてプロパティを開けるよう変更
  (設定ダイアログから無効にすることができます)

- [水彩境界・用紙質感] 発色を調整、新しいモードとして[ディープ]と[乗算]を追加
  ([ディープ]は旧仕様の[水彩境界]＋[用紙質感]、[乗算]は旧仕様の[極彩境界]＋同系の色演算の用紙質感、となります)


--------------------------------------------------------------------------------------------------------------------------------------------
2016-06-20版

[バグ修正]

- [最近使用したファイル] 最近使用したファイルに一件も登録されていない場合にプログラムがエラーで終了する

- [キャンバス保存・読込] キャンバスの背景色の取り扱いが正しくできてない

- [SAI形式] レイヤーマスクを正しく読み込めない

- [JPEG形式] CMYKなど対応していない形式のJPEGファイルを読み込もうとすると内部エラーのポップアップが表示される
  (修正後は非対応形式の読み込みはエラーダイアログが表示されるのみとなります)

- [レイヤー] レイヤーを削除して画像を持たないレイヤーのみとなった場合にアクセス違反が発生する

- [ヒストリ] キャンバス外の画像のUndoが正しく実行できず暴走する場合がある


[変更]

- [SAI形式] テスト版時代の*.saiファイルをエラーで弾くよう変更
  (いずれ対応する予定です)


--------------------------------------------------------------------------------------------------------------------------------------------
2016-06-19版

[新機能]

- JPG, PNG, TGA形式の保存・読込

- SAI形式の読込

- HSV/HSLスライダ、中間色バー、ユーザーパレット
　(スクラッチパッドは廃止を検討しています)

- レイヤーの可視状態を操作するショートカット

- レイヤーリスト上の選択項目を変更するショートカット

- スポイト系ショートカット

- 表示レイヤーの結合、画像の統合

- 選択領域の１ピクセル膨張・収縮
  (Ver.1の[選択領域を１ピクセル膨張]と同様の菱形の膨張・収縮処理です)

- フィルタ
　・色相・彩度
　・明るさ・コントラスト
　・ガウスぼかし

- ブラシ円のON/OFF、ブラシ系ツールのドットカーソル

- ブラシ系ツールの描画モード


[バグ修正]

- [最近使用したファイル] 長さが128文字を超えているパス名があると起動時にアクセス違反で強制終了する

- [ブラシ系ツール] ブリスルの方向に[ペンの方向]を指定した場合にビューの表示角度や反転が反映されない

- [水彩筆] ブラシサイズが15以下の場合にぼかしの処理が正しく動作しない

- [マーカー] マーカー本来の動作になっていない
  (2016-03-19版のバグ修正で直し切れていませんでした)

- [ペン入れレイヤー] 筆圧制御点の作成をOFFにしても筆圧制御点が作成される

- [レイヤー移動] カーソルキーでのレイヤー移動にビューの反転が反映されない

- [パース定規] パース定規とパースグリッドの新規作成のショートカットが動作しない

- [矩形選択ツール] Shift併用時に右下方向か左上方向にしか選択できない

- [選択領域の膨張・収縮] 特定条件下で処理範囲の右端と下端にゴミが出る

- [キャンバス解像度の変更] 倍率によってはリサイズに失敗して回復できない

- [キャンバスを選択領域の大きさで切り抜く] キャンバスの外側の画像が消去されない


[変更]

- [操作パネル] カスタムツールトレイの項目のドラッグ処理をVer.1とほぼ同じ仕様に変更

- [エラー処理] ファイル入出力関連のエラーをエラーログにも記録するよう変更

- [WinTab制御] ドライババージョンの取得でエラーが発生してもログに記録するのみに変更
  (一部のドライバがバージョン取得のAPI呼び出しでエラーを返すため)

- [キャンバス] 背景色の選択肢を追加

- [ビュー] 最大表示倍率を 3200% に変更

- [レイヤー結合] 複数選択でのレイヤー結合の結果をカレントレイヤーのあった場所に配置するよう変更
  (結合後のレイヤー名もカレントレイヤーの名前を継承するようにしました)

- [水彩境界・用紙質感] 発色を調整

- [水彩境界・用紙質感] キャンバスメニューに[特殊効果の発色]を追加
  ([極彩境界]相当の効果は名称を[ビビッド]として[特殊効果の発色]の中に移設しました。

- [スポイトツール] ドラッグ中も色を拾うかどうかの設定を追加


--------------------------------------------------------------------------------------------------------------------------------------------
2016-03-19版

[バグ修正]

- [マーカー] マーカー本来の動作になっていない
  (2016-03-17版のVer.1との互換処理に関する修正でエンバグさせていました)


[変更]

- [タブレット制御] TabletPC APIを使用する場合にWinTab APIのDLLのロードが行われないよう変更
  (WinTab APIを呼び出さなくてもDLLがロードされた時点でTabletPC APIが無効になってしまうタブレットドライバが存在するようだったので)


--------------------------------------------------------------------------------------------------------------------------------------------
2016-03-17版

[新機能]

- ２値ペン

- カラー２値化
  (レイヤー関連パネルの[特殊効果]で指定するようにしました)


[バグ修正]

- [キャンバス新規作成] 「規定のサイズ」が正常に動作していない

- [レイヤー] 不可視のレイヤーを選択すると可視アイコンが淡色表示になりレイヤー関連のUI部品の無効状態が解除される

- [レイヤーマスク] サムネールクリックによる選択領域の作成が正常に動作しない

- [レイヤーマスク] レイヤー塗り潰しが常に白(255,255,255)で塗り潰したのと同じ状態になる

- [ビュー] ビューを閉じた際にアクセス違反が発生してその後の動作が不安定になる


[変更]

- [ブラシ系ツール] [濃度増幅]のパラメータの影響を調整
  (100にするとVer.1に近い描線が得られるようになります)

- [ブラシ系ツール] [Ver1筆圧特性]のパラメータの追加
  (ONにするとブラシ濃度の筆圧特性がVer.1とほぼ同等になります)

- [ペン入れレイヤー] 筆圧制御点の矩形選択(Ctrl+Shift+範囲指定)を筆圧ツール選択中のみ使用可能になるように変更

- [ペン入れレイヤー] ペン入れレイヤーでもレイヤーの選択＆移動(Ctrl+Shift)が使用できるよう変更
  (但し、ストローク編集の操作と被るのですでに選択されているレイヤーに対しては実質的に選択＆移動ができません)

- [操作パネル] 色・ツール関連パネルのスクロールバーを常時表示するよう変更
  (レイヤーの選択＆移動でスクロールバーがON/OFFされた場合にビューウィンドウ自体が動いてレイヤーの移動が暴発してしまうので、
  ひとまずスクロールバーを常時表示して回避するようにしました)

- [グラデーションツール] 階調の品質を改良

- [画像変形系] バイキュービック方式とLanczos方式のリンギングの現れ方を調整
  例えば透明なレイヤーに描かれたエッジの立った太い線を変形した際に次のような副作用がありました。

   1. 線の輪郭付近の外側にほぼ透明なピクセルがノイズ状に生成される
   2. 線の輪郭付近の内側のピクセルの不透明度がノイズ状にわずかに下がる

  バイキュービック と Lanczos 2 では 1. と 2. 共に完全に抑制されるように修正しました。
  Lanczos 3 は 1. のみできるだけ抑制されるように修正しましたが、アルゴリズムの性質上完全な抑制はできません。

- [キャンバス解像度の変更] 水彩境界と用紙質感もリサイズされるように変更
  (但し、水彩境界は1～15、用紙質感は10%～500%の範囲の整数粒度でのリサイズとなります)


--------------------------------------------------------------------------------------------------------------------------------------------
2016-01-24版

[バグ修正]

- [キャンバス解像度の変更] サイズの単位が％の場合に印刷解像度を変更するとサイズが 0px×0px になる

- [レイヤー] レイヤー作成時などの編集に伴うツールセットの切り替えでスクロールバーがON/OFFされるとフリーズする

- [ペン入れレイヤー] ストロークの接続で筆圧制御点が壊れる


--------------------------------------------------------------------------------------------------------------------------------------------
2016-01-23版

[バグ修正]

- [SAI2ファイル] パース定規やパースグリッドが含まれるファイルの読み込みがアクセス違反で失敗する


--------------------------------------------------------------------------------------------------------------------------------------------
2016-01-22版

[新機能]

- クリップボードからのキャンバスの作成

- 最近使ったファイル

- キャンバスを閉じる

- キャンバス間のレイヤーのコピー
  (ビューを最大化していない状態でレイヤー項目を他のキャンバスのビューへドラッグする)

- 右クリック時のビューの表示位置のリセット (手のひらツール、ビュー拡大ツール)

- 右クリック時のビューの表示角度のリセット (ビュー回転ツール)


[バグ修正]

- [ツール] ショートカットキーの割り当てダイアログで投げ縄ツールと自動選択ツールの名前が逆になっている

- [レイヤー] 選択＆移動で選択したレイヤー項目がスクロールインしない

- [レイヤー] ペン入れレイヤーと図形レイヤーを通常レイヤーへ転写するとアクセス違反が発生する

- [選択領域] 膨張または収縮を行おうとするとアクセス違反が発生する

- [PSD形式] 読み込み時にキャンバスサイズの単位を正しく処理しておらず、キャンバスの解像度変更などでアクセス違反が発生する

- [ショートカットキー] プログラムを再起動しないと割り当ての変更がメインメニューに反映されない

- [グラデーションツール] グラデーションツールの新規作成後にプレビューでグラデーションの向きを反転させるとアクセス違反が発生する


[変更]

- [グラデーションツール] 階調の品質を改良

- [グラデーションツール] 始点と終点どちらか近いほうの制御点が常にヒットするよう変更


--------------------------------------------------------------------------------------------------------------------------------------------
2016-01-19版

[新機能]

- キャンバス解像度の変更

- キャンバスサイズの変更

- キャンバスの反転・90度回転

- キャンバスを選択領域の大きさで切り抜く

- レイヤーの輝度を不透明度に変換

- 画像変形

- レイヤーの反転・90度回転

- ２点／３点パースグリッド

- レイヤー画像からの選択領域の作成・追加・除去
  (レイヤーリストのサムネールを修飾キー＋クリックすると実行できます)
                 Ctrl + クリック ... 画像から作成した領域で置き換える
         Shift + Ctrl + クリック ... 画像から作成した領域を追加する
   Alt +         Ctrl + クリック ... 画像から作成した領域を削除する
   Alt + Shift + Ctrl + クリック ... 画像から作成した領域と重なる部分だけを残す

- グラデーションツール

- [ペンタブレット] "sai.ini" にタブレットドライバのバグを回避するための設定項目を追加


[バグ修正]

- [マウス操作] 一部のデバイスによるマウスホイール操作が正しく動作しない

- [ウィンドウ制御] 起動時のフレームウィンドウの配置の復元でウィンドウサイズがWindowsが決定する初期値より小さくならない

- [ウィンドウ制御] 高DPI環境で描画色＆背景色の部品のレイアウトが崩れる

- [ビュー] 同一のキャンバスの複数ビューを切り替えた際に選択境界が表示されない場合がある

- [ビュー] 最大化された通常ビューからフローティングビューに切り替えた場合に通常ビューが再描画されなくなる場合がある

- [レイヤー描画] フローター(選択領域による切り取り移動)がある状態でレイヤーの塗り潰し等を行うとアクセス違反が発生する

- [レイヤー選択移動] 非表示のレイヤーやクリッピングで隠されている部分が選択対象に含まれる

- [ブラシ系ツール] ブリスル(丸筆・平筆等)の定義データに64点以上の毛点が含まれているとアクセス違反が発生する

- [筆系ツール] ブラシパターンの外側にある色が混色される場合がある

- [選択系ブラシ] Ctrl+Altでのブラシサイズ変更が動作しない

- [文字レイヤー] 改行が使用できない
  (10/19版のEnterキーとEscキーに関する修正でエンバグさせていました)

- [文字レイヤー] キャンバス外にはみ出した文字が描画されない場合がある

- [パース定規] 複製したパース定規が動作しない

- [定規・パース定規] スペースを押すと定規が消える

- [選択領域の膨張・収縮] レイヤーマスクが選択されている状態で膨張・収縮を行おうとするとフリーズする

- [PSD形式の読み込み] 10/19版で仕様変更したもの以外の合成モードで常にPhotoshop上の[塗り]がSAI上の[レイヤー不透明度]に適用される


[変更]

- [ショートカットキー] サポートされていない機能のショートカットキーの設定が失われないよう変更
  (このバージョン以降は古いバージョンを起動してもそのバージョンでサポートされていない機能のショートカットキー設定が失われなくなります)

- [キャンバス] 背景色の設定をレイヤートレイからメニューに移動
  (パース定規のボタンと押し間違えることが多いように思ったので変更しました)

- [ビュー] 拡大縮小を繰り返した際にキャンバスが画面外に飛び出しにくい動作に変更

- [ペンタブレット] Ver.1と同様にテールスイッチで別のツールを選択できるよう変更

- [ブラシ系ツール] 定規無効モード(Shift)と直線モード(Alt+Shift)への切り替えを修飾キーではなくクイックバー上のボタンに変更
  (ショートカットキーを割り当てた場合は機能シフトの対象となります。)

- [ブラシ系ツール] ストロークのイリを付け易いよう調整
  (Wacomの一部の機種ではペンの自重だけで30%近い筆圧値が出てくるので、そのような機種でもイリを付けられるよう調整しました)

- [ブラシ系ツール] ブリスル(丸筆・平筆等)に[バラつき]と[方向]のパラメータを追加
  (これまでは毛点の位置に常に直径の最大10%のバラつきが適用されていました)

- [ブラシ系ツール] テクスチャ使用時に[最小濃度]をかすれの強さに影響させるかどうかの指定を追加
  (これまでは常にかすれの強さに影響させる仕様になっていました)

- [ブラシ系ツール] [濃度増幅]のパラメータを追加
  (濃度の[筆圧感度]を200%付近にして[濃度増幅]を+100%にすると描画濃度の特性がVer.1とほぼ同じになります)

- [水彩筆] 初期設定でより平易にぼかしを行えるよう調整

- [マーカー] 筆圧の減衰により描画濃度が下り坂になる部分の描画品質を向上

- [選択ペン・選択消し] [ブラシ濃度]を100にした場合に１ストロークで100%の塗りができるよう変更
  (Ver.1と同じ仕様にしました)

- [キャンバス保存] 一旦別名で保存する際の拡張子を画像拡張子から .tmp に変更
  (Bridge CS6を使用している際にサムネール作成と衝突して保存が失敗する場合があったので画像拡張子を付けないようにしました)


--------------------------------------------------------------------------------------------------------------------------------------------
2015-10-19版

[新機能]

- 自動選択・バケツ
  * Ver.1からの変更点 *
   + 線が途切れている箇所からの漏れ出しを防止する機能を追加
   + 色差が範囲内にある全ピクセルを選択する機能を追加
   - 透明部分(あいまい)を廃止
  (以前のバージョンのSAI2を正常起動したことがあるとバケツツールは自動的に作成されません。カスタムツールトレイの空きスロットを右クリックして
  表示されるコンテキストメニューから[バケツ]を選択して作成してください)

- 投げ縄ツール
  * Ver.1からの変更点 *
  + 多角形選択を追加

- レイヤー画像の切り取り・コピー・貼り付け

- ペン入れレイヤー・図形レイヤー・文字レイヤーのラスタライズ

- 選択領域の膨張・収縮


[バグ修正]

- 描画した部分をキャンバス外に移動させた状態でレイヤーの結合を行うと暴走する
  (7/18版の修正で直し切れていませんでした)

- 選択系ブラシでキャンバスの右端と下端を描画すると後のブラシ描画の異常やアクセス違反が発生する

- キャンバスのサイズによってはキャンバスの右端と下端の選択領域の境界線が表示されない場合がある

- 選択領域の表示状態が境界線から色に切り替わった際に一部の境界線が消えずに残る場合がある

- 一部のメーカーのペンタブレットを使用している場合にWinTab APIの初期化に失敗する

- 一度でもショートカットキーの割り当て変更を行うとEnterキーとEscキーで曲線・折線ツールの確定ができなくなる

- .sai2形式から読み込んだキャンバスの、レイヤーフォルダの開閉・レイヤー選択状態・レイヤー保護状態の解除操作が最初の一度だけ動作しない

- 図形レイヤー選択時のカスタムツールトレイのコンテキストメニューに図形レイヤー用ツールを作成する項目が無い

- 文字レイヤーの削除の情報がヒストリファイルに追い出されているとUndo/Redoしてもテキストが復元されない


[変更]

- レイヤー結合の仕様を変更
  ・複数選択したレイヤーの結合に対応
  ・クリッピンググループの親が選択されている場合はグループを単独で統合するように変更

- PSD保存で以下の合成モードの不透明度をPhotoshopでの「塗り」に反映されるように変更
  ・陰影       (Photoshopでは [焼き込み(リニア)])
  ・発光       (Photoshopでは [覆い焼き(リニア)])
  ・陰影＆発光 (Photoshopでは [リニアライト]    )
  ・焼き込み   (Photoshopでは [焼き込みカラー]  )
  ・覆い焼き   (Photoshopでは [覆い焼きカラー]  )
  ・焼き＆覆い (Photoshopでは [ビビッドライト]  )


--------------------------------------------------------------------------------------------------------------------------------------------
2015-07-18版

[バグ修正]

- キャンバスの横ピクセル数が奇数で背景が透明だとファイル形式に関わらず保存が「内部状態に不整合が発生しました」となって失敗する

- レイヤーフォルダが存在する場合に.sai2形式の保存が「内部状態に不整合が発生しました」となって失敗する

- 背景が透明の場合の.bmp保存で不透明度の有無の情報が正しく出力されない
  (BITMAPV4HEADER の bV4AlphaMask を 0 として出力していました)

- 描画した部分をキャンバス外に移動させた状態でUndo/Redoを行うと暴走する場合がある

- 用紙質感を設定したフォルダを統合すると質感が見えなくなる


--------------------------------------------------------------------------------------------------------------------------------------------
2015-07-10版

今回は目に見えない部分で大規模な改修を行いました。かなり厳重にデバッグしたつもりですがまだ見落としている箇所があるかもしれません。
どのテスト版にも言える事ではありますが特にこのバージョンは大切な作品の製作には使用なさらないでください。

[新機能]

- 統合画像に対するスポイト

- 編集中でないビューに対するスポイト

- レイヤーの選択＆移動
  ([Ctrl + Shift + ドラッグ]で使用できます。移動ツールで設定を変更すると[Ctrl + ドラッグ]でも選択＆移動が使用できるようになります)

- レイヤーのナッジ
  ([Ctrl + カーソルキー]でレイヤー移動、[ALt + カーソルキー]で選択領域のみの移動、Shiftを組み合わせると移動量増加となります)


[バグ修正]

- Ctrl + Alt によるブラシサイズの変更でスライダが常に最初に作成したビューに表示される

- 形式を問わず一部の画像ファイルの読み込みに失敗する

- メモリ使用量の表示が動作していない
  (表示更新のタイマーを設定する際のタイマーIDを別のタイマー処理と重複させてしまっていました)

- 同一のレイヤーを連続して移動させた際に２回目以降の操作で[編集あり]の状態が設定されない
  (例えば、移動 → 保存([編集あり]がクリアされる) → 移動([編集あり]とならない)、といった状態になっていました)

- メモリ不足が発生すると暴走する
  (メモリ不足からの回復処理は厳重にテストしていたのですが、大元のメモリマネージャの中でポカミスをしていました)


[変更]

- 描画に関するヒストリ処理を刷新
  (大径ブラシを描画した後の引っ掛かりを大幅に軽減しました。また、ヒストリデータがメモリ上にある場合の描画のUndo/Redoの速度を大幅に
  高速化しました)

- sai2形式の保存と読込のデータ圧縮・展開の工程をマルチコアに対応
  (参考までにですが、弊社環境(Xeon E5420(4core) x2, Memory 16GB, HDD 10000rpm)では2.5倍程度の高速化となりました)

- ブリスルの描画品質を向上
  (速度は2/3程度に落ちたのですが、例えば平筆でぼかしと着色を半々程度の筆圧で描画した場合のシャコの剥き身を並べたみたいな気色悪い筆跡が
  出なくなりました)

- ヒストリデータファイルの出力先ドライブの情報の表示を追加


--------------------------------------------------------------------------------------------------------------------------------------------
2015-04-25版

[バグ修正]

- 何か描画されているレイヤーの下に何も描画されていないレイヤーがあるとPhotoshopで読み込めないPSDファイルが作成される
  (空のレイヤーの成分データのサイズを間違って出力していました)


--------------------------------------------------------------------------------------------------------------------------------------------
2015-04-24版

[バグ修正]

- ピクセル不透明度の保護が動作しない
  (レイヤーマスクの実装を行った際にエンバグさせていました)

- PSDファイルのレイヤーマスクの保存と読込が正常に動作しない

- PSDの不透明度付き統合画像のRGB値の扱いが間違っている

- レイヤーの移動とレイヤーへの描画を繰り返した場合に暴走する場合がある
  (巨大なキャンバスで顕著に発生していました)

- 選択領域を解除した際に境界線が残る場合がある

- レイヤー名の変更のUndo/Redoが正常に動作しない


[変更]

- 旧バージョンを起動しても新しいバージョンで新設された設定が消えないように変更
  (設定の保存先ファイルを変更したため、旧バージョンの設定は引き継がれません。お手数ですが再設定をお願い致します)

- Alt + Space でシステムメニューを表示するかどうかを設定できるように変更
  (初期設定では Alt + Space でのシステムメニュー表示を無効にしました)


--------------------------------------------------------------------------------------------------------------------------------------------
2015-04-22版

[バグ修正]

- Photoshopで読み込めないPSDが作成される
  (キャンバスの背景が透明の場合に統合画像も不透明度を含むようにしたのですが、その際にPSDヘッダのチャンネル数に 4 を指定するのが抜かって
  いました。Photoshop CCでは特定のサイズの画像でチャンネル数が 4 でなくても読み込めてしまう場合があり、テスト時は偶然にもその読み込めて
  しまうサイズで確認を行ったため見落としてしまいました。申し訳ありません)

- パスをベジェ方式から他の方式に変更する操作をUndoした場合にハンドルの情報が復元されない

- ペン入れレイヤーや図形レイヤーを下のレイヤーに転写した場合に制御点が表示されたままになる

- パスの制御点が表示されている場合に Space + 修飾キー + ドラッグの操作ができない


--------------------------------------------------------------------------------------------------------------------------------------------
2015-04-21b版

[バグ修正]

- メニュー開いただけでアクセス違反
  (ごめん)


--------------------------------------------------------------------------------------------------------------------------------------------
2015-04-21a版

[バグ修正]

- PSD/PSB保存時にアクセス違反が発生する
  (作業用のバッファのサイズの計算で大ポカをやらかしていました。申し訳ありません)


[変更]

- キャンバスを保存しているかどうかの内部状態を厳密に処理するように変更
  (タイトルバーのファイル名の後ろの括弧内の記号で表されます。記号の意味は以下の通りです。
      * ... 未保存
      ! ... .sai2形式以外で保存されたが、SAI独自の情報が保存されていない
      - ... レイヤーの可視状態などヒストリに反映されない情報が変更された)


--------------------------------------------------------------------------------------------------------------------------------------------
2015-04-21版

[バグ修正]

- 曲線ツール・折線ツールを使用した瞬間にアクセス違反が発生する

- パスの複製移動でRedoが動作しない

- 特定のキャンバスサイズで全選択(Ctrl+A)を行うとアクセス違反が発生する

- 選択領域のみを連続して移動させた場合にヒストリの結合がされない

- ペン入れレイヤーの筆圧変更ツールで濃度の変更ができない


[変更]

- レイヤーフォルダ・テキスト・パース定規を選択している場合のカスタムツールセットを通常レイヤーと同じものが表示されるよう変更
  (マスク用ブラシがレイヤーの種類ごとに用意されていても有用ではないと気が付いたので。。。マスク用ブラシは最終的に共通ツール欄に
  移すかもしれません)

- レイヤーにツールを使用できない状態ならマウスカーソルで禁止状態を表すよう変更

- 消しゴムとマスク用ブラシのマウスカーソルを専用のものに変更


--------------------------------------------------------------------------------------------------------------------------------------------
2015-04-20版

[新機能]

- PSD形式とPSB形式のファイルの保存・読込
  (但し対応しているのは Ver.1 と同程度、「基本的なレイヤー構造」「ピクセルデータ」「レイヤーマスク」のみです。文字レイヤーについては
  詳細が文書化されていないため対応は難しいと思われます。簡単な文字情報ですらPhotoshopと表示結果を合わせることは難しいように思いました)

- レイヤー合成モードの追加
  ・陰影       (Photoshopでは [焼き込み(リニア)] (*1))
  ・発光       (Photoshopでは [覆い焼き(リニア)] (*1))
  ・陰影＆発光 (Photoshopでは [リニアライト]     (*1))
  ・焼き込み   (Photoshopでは [焼き込みカラー]   (*1))
  ・覆い焼き   (Photoshopでは [覆い焼きカラー]   (*1))
  ・焼き＆覆い (Photoshopでは [ビビッドライト]   (*1))
    (*1) Photoshop上ではさらに[透明シェイプレイヤー]を OFFとなる。

  ・Photoshopとの互換モード (但し演算精度等の違いによりPhotoshopでの合成結果と厳密には一致しません)
    + 比較(暗)、焼き込みカラー、焼き込み(リニア)、カラー比較(暗)
    + 比較(明)、覆い焼きカラー、覆い焼き(リニア)、カラー比較(明)
    + ソフトライト、ハードライト、ビビッドライト、リニアライト、ピンライト、ハードミックス
    + 差の絶対値、除外、減算、除算
    + 色相、彩度、カラー、輝度

- レイヤーマスク

- キャンバスの背景色の設定 (白、黒、格子(明)、格子(暗))

- 筆系ツールのショートカット (ブラシサイズと描画濃度の変更)


[バグ修正]

- ナビゲータの表示倍率および表示角度のトラックバーを素早く操作するとマウスカーソルと描画位置がずれる

- キャンバスの水平ピクセル数が32px以下だとキャンバスの作成に失敗する

- 32bit版でブリスルの描画がおかしい
  (MMXステートのクリアが抜けている箇所がありx87命令が誤動作していました。もしかすると.sai2保存時のファイル破損の遠因だったかもしれません)

- 閉じられたレイヤーフォルダの中のレイヤーがUndo/Redoされた際にフォルダを開いてレイヤー項目を表示する動作で無関係のフォルダも開いてしまう

- 通過モードのレイヤーフォルダを不可視にした場合にそれより上層のレイヤー項目が全て不可視になってしまう

- フォルダを結合すると中身が空になってしまう
  (2015-01-02版のレイヤー結合の修正でエンバグさせていました)

- PCを再起動するとシステムIDが変わってしまいライセンス証明書が認識されなくなる
  (\\.\PhysicalDrive0 の情報を利用していたのですが、PCを再起動すると \\.\PhysicalDriveX と物理デバイスのマッピングが変わってしまう
  場合があることが分かりましたので、Windowsのシステムドライブの情報を利用するように修正しました)

- 筆系ツールの形状やテクスチャで名称が日本語の項目が選択されていると設定が保存されない

- レイヤー合成モードでオーバーレイを指定したレイヤーに用紙質感を指定すると色化けが発生する

- マイドキュメントをドライブ直下に変更している場合にデータフォルダの作成に失敗して起動できない
  (PathRemoveBackslash() というパス名の末尾の \ を除去するAPIを使用していましたが、例えば C:\foo\ を渡すと C:\foo になりますが C:\ を
  渡すと \ が除去されず C:\ のままになるという仕様になっていることに気が付いていませんでした。)

- 現在のヒストリデータをすべてUndoした状態でキャンバスを閉じると保存するかどうかを確認するダイアログが表示されない

- ツールチップが画面左の外にはみ出してしまう


[変更]

- Windows 8/8.1で発生するTabletPC API使用時のブラシストロークの遅延が発生しないように変更
  (Win8系ではプレスアンドホールドとフリックを無効にしてもマウスイベントの発生の遅延が無くならないことが原因でした。今回対策したのは
  ビューだけですが、ビュー以外でも対策するかどうかは検討中です)

- TabletPC APIを強制的に使用できるよう変更

- ツール選択キーの二度押しで選択を元に戻す機能の不明瞭な動作を改善

その他細かい調整


--------------------------------------------------------------------------------------------------------------------------------------------
2015-01-20版

[バグ修正]

- .sai2形式の読み込みに失敗する場合がある

- ツールのプロパティでショートカットキーの無効化ができない

- ショートカットキーの割り当ての初期設定がされない
  (対処としてはショートカットキー割り当てダイアログで[初期設定に戻す]ボタンを押すことで手作業で設定する手間を省けます)


--------------------------------------------------------------------------------------------------------------------------------------------
2015-01-19版

[新機能]

- マーカー
  (以前のバージョンのSAI2を正常起動したことがあるとマーカーは自動的に作成されません。カスタムツールトレイの空きスロットを右クリックして
  表示されるコンテキストメニューから[マーカー]を選択して作成してください)

- ナビゲータ

- ショートカットキーの割り当て設定ダイアログ

- 設定ダイアログ(暫定)


[バグ修正]

- 修正液ツールの[交点まで消去]が水平線と垂直線に対して正常に動作しない

- レイヤーフォルダでスポイトを使用するとアクセス違反が発生する

- 筆と水彩筆でブラシ形状に丸筆か平筆を選択している場合に希釈を 1 以上にすると色が出ない
  (2015-01-01版で修正した混色の問題に関連する部分で見落としがありました)

- フローティングビューを作成すると最大化されている通常ビューが描画されない

- タブレット操作からマウス操作への切り替えが正常に動作しない場合がある

- 選択領域の境界線が正常に描画されない

- 筆と水彩筆で希釈を 1 以上にした場合にキャンバスの右外側と左外側のピクセルが混色に含まれてしまう

- ブラシ及び用紙質感のテクスチャの寸法の上限が1024x1024「以内」ではなく「未満」になっていた

- 複数キーが同時に押下された場合の開放の検出が正しく動作しない
  (2015-01-02版で修正した一部キーの押下でフリーズする問題に関連する部分で見落としがありました)

- ヒストリデータのファイルへの追い出しでデータを間違った位置に書き込んでしまいUndoが正常動作しなくなる場合がある
  (例えば、1.描画 → 2.レイヤー移動 → 3.Undo → 4.描画 という操作を行うと 1. のヒストリデータを 4. のデータで上書きしてしまっていました)


[変更]

- キャンバスを閉じる際の保存確認のボタンをVer.1と同じ並びに変更

- 初回起動時の作業フォルダの作成でエラーを詳しく報告するように変更


--------------------------------------------------------------------------------------------------------------------------------------------
2015-01-02版

[バグ修正]

- パース定規の方向判定が正しく動作しない

- キャンバスからはみ出したレイヤーを結合するとアクセス違反が発生する

- 一部のキーを押すとフリーズが発生する


[変更]

- 実行ファイル名を sai.exe から sai2.exe に変更
  (この変更により一部の環境でワコムのタブレットドライバが誤動作していた問題が改善されたようです)


--------------------------------------------------------------------------------------------------------------------------------------------
2015-01-01版

[バグ修正]

- 混色の筆圧計算で未初期化の値を使用していた
  (楕円定規を使用した場合に色化けが露呈していましたが、通常の描画でも起こり得る問題でした)

- 二重に起動しようとするとアクセス違反が発生する

- ブリスルのデータ(丸筆と平筆)をうっかり入れ忘れていた
  (結果として空フォルダを展開しない展開ソフトを使用した場合に必要なフォルダが作成されず起動時にエラーが発生していたと思われます)


--------------------------------------------------------------------------------------------------------------------------------------------
2014-12-31版

[新機能]

- ペン入れレイヤー
  * Ver.1からの改良点 *
   + 曲線生成アルゴリズムを刷新
   + ベジェ曲線モードを追加
   + 修正液ツールに交点まで消去する機能を追加

- 図形レイヤー(基本部分のみ)

- .sai2形式と.bmpの保存・読込


[その他]

- プログラムの土台部分の作り込み

- 2013-12-10版にあった諸々の問題を修正


--------------------------------------------------------------------------------------------------------------------------------------------
2013-12-10版

- 中途版リリース


--------------------------------------------------------------------------------------------------------------------------------------------
2011年10月

- Ver.2 開発スタート


